--------------------------------------------------------------------------------
-- <auto-generated>
-- This code was generated by a tool.
--
-- Changes to this file may cause incorrect behavior and will be lost if
-- the code is regenerated.
-- </auto-generated>
--------------------------------------------------------------------------------
    
IF DB_NAME()='master'
BEGIN
    RAISERROR(N'Unable to execute script on master database, USE a database before running this script',16,1)
    RETURN
END

SET NOCOUNT ON
SET XACT_ABORT ON
SET IMPLICIT_TRANSACTIONS ON
SET QUOTED_IDENTIFIER ON

GO

CREATE FUNCTION GetLearnerAssignmentState(
@RootActivityId bigint,
@IsFinal bit,
@NonELearningStatus int,
@AttemptStatus int)
RETURNS int
AS
BEGIN
RETURN CASE WHEN @RootActivityId IS NOT NULL
THEN
-- e-learning content
CASE WHEN @AttemptStatus IS NULL
THEN 0 -- LearnerAssignmentState.NotStarted
ELSE
CASE WHEN @IsFinal = 1
THEN 3 -- LearnerAssignmentState.Final
ELSE
CASE WHEN @AttemptStatus = 0 OR @AttemptStatus = 3
THEN 1 -- LearnerAssignmentState.Active
ELSE 2 -- LearnerAssignmentState.Completed
END
END
END
ELSE
-- non-e-learning content
CASE WHEN @NonELearningStatus IS NULL
THEN 0 -- LearnerAssignmentState.NotStarted
ELSE
CASE WHEN @IsFinal = 1
THEN 3 -- LearnerAssignmentState.Final
ELSE
CASE WHEN @NonELearningStatus = 0 OR @NonELearningStatus = 3
THEN 1 -- LearnerAssignmentState.Active
ELSE 2 -- LearnerAssignmentState.Completed
END
END
END
END
END

GO

CREATE FUNCTION IsLearnerAssignmentStarted(
@RootActivityId bigint,
@NonELearningStatus int,
@AttemptStatus int)
RETURNS int
AS
BEGIN
RETURN CASE WHEN @RootActivityId IS NOT NULL
THEN
-- e-learning content
CASE WHEN @AttemptStatus IS NULL
THEN 0 -- LearnerAssignmentState.NotStarted
ELSE 1 -- LearnerAssignmentState.Active or Completed or Final
END
ELSE
-- non-e-learning content
CASE WHEN @NonELearningStatus IS NULL
THEN 0 -- LearnerAssignmentState.NotStarted
ELSE 1 -- LearnerAssignmentState.Active or Completed or Final
END
END
END

GO

-- Create configuration table
CREATE TABLE Configuration (
    EngineVersion int NOT NULL,
    SchemaDefinition xml NOT NULL
)
DECLARE @schema varchar(max)
SET @schema = '<StoreSchema>'
SET @schema = @schema +
    '<ItemType Name="ActivityAttemptItem" ViewFunction="ActivityAttemptItem$DefaultView">' + 
        '<Property Name="AttemptId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="AttemptItem"/>' +
        '<Property Name="ActivityPackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="CompletionStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="CompletionStatus"/>' +
        '<Property Name="AttemptCount" TypeCode="9" Nullable="true" HasDefault="true"/>' +
        '<Property Name="DataModelCache" TypeCode="7" Nullable="true" HasDefault="true"/>' +
        '<Property Name="EvaluationPoints" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Exit" TypeCode="8" Nullable="true" HasDefault="true" EnumName="ExitMode"/>' +
        '<Property Name="LessonStatus" TypeCode="8" Nullable="true" HasDefault="true" EnumName="LessonStatus"/>' +
        '<Property Name="Location" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MinScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MaxScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ProgressMeasure" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="RandomPlacement" TypeCode="9" Nullable="true" HasDefault="true"/>' +
        '<Property Name="RawScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ScaledScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SequencingDataCache" TypeCode="7" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SessionStartTimestamp" TypeCode="4" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SessionTime" TypeCode="6" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SuccessStatus" TypeCode="8" Nullable="true" HasDefault="true" EnumName="SuccessStatus"/>' +
        '<Property Name="SuspendData" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="TotalTime" TypeCode="6" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="ActivityObjectiveItem" ViewFunction="ActivityObjectiveItem$DefaultView">' + 
        '<Property Name="ActivityPackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="IsPrimaryObjective" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="Key" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="MinNormalizedMeasure" TypeCode="5" Nullable="false" HasDefault="true"/>' +
        '<Property Name="SatisfiedByMeasure" TypeCode="3" Nullable="false" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="ActivityPackageItem" ViewFunction="ActivityPackageItem$DefaultView">' + 
        '<Property Name="ActivityIdFromManifest" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="OriginalPlacement" TypeCode="9" Nullable="false" HasDefault="false"/>' +
        '<Property Name="ParentActivityId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="PackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="PackageItem"/>' +
        '<Property Name="PrimaryObjectiveId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityObjectiveItem"/>' +
        '<Property Name="ResourceId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ResourceItem"/>' +
        '<Property Name="PrimaryResourceFromManifest" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="DataModelCache" TypeCode="7" Nullable="true" HasDefault="true"/>' +
        '<Property Name="CompletionThreshold" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Credit" TypeCode="3" Nullable="true" HasDefault="true"/>' +
        '<Property Name="HideContinue" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="HidePrevious" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="HideExit" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="HideAbandon" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="IsVisibleInContents" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="LaunchData" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MasteryScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MaxAttempts" TypeCode="9" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MaxTimeAllowed" TypeCode="6" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ResourceParameters" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ScaledPassingScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="TimeLimitAction" TypeCode="8" Nullable="true" HasDefault="true" EnumName="TimeLimitAction"/>' +
        '<Property Name="Title" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="ObjectivesGlobalToSystem" TypeCode="3" Nullable="false" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="PackageGlobalObjectiveItem" ViewFunction="PackageGlobalObjectiveItem$DefaultView">' + 
        '<Property Name="LearnerId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
        '<Property Name="GlobalObjectiveId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="GlobalObjectiveItem"/>' +
        '<Property Name="ScaledScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SuccessStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="SuccessStatus"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="AttemptItem" ViewFunction="AttemptItem$DefaultView">' + 
        '<Property Name="LearnerId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
        '<Property Name="RootActivityId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="CompletionStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="CompletionStatus"/>' +
        '<Property Name="CurrentActivityId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="SuspendedActivityId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="PackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="PackageItem"/>' +
        '<Property Name="AttemptStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="AttemptStatus"/>' +
        '<Property Name="FinishedTimestamp" TypeCode="4" Nullable="true" HasDefault="true"/>' +
        '<Property Name="LogDetailSequencing" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="LogFinalSequencing" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="LogRollup" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="StartedTimestamp" TypeCode="4" Nullable="true" HasDefault="false"/>' +
        '<Property Name="SuccessStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="SuccessStatus"/>' +
        '<Property Name="TotalPoints" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="LearnerAssignmentId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="AttemptObjectiveItem" ViewFunction="AttemptObjectiveItem$DefaultView">' + 
        '<Property Name="ActivityAttemptId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Property Name="ActivityObjectiveId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityObjectiveItem"/>' +
        '<Property Name="CompletionStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="CompletionStatus"/>' +
        '<Property Name="Description" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="IsPrimaryObjective" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="Key" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="LessonStatus" TypeCode="8" Nullable="true" HasDefault="true" EnumName="LessonStatus"/>' +
        '<Property Name="RawScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MinScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MaxScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ProgressMeasure" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ScaledScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SuccessStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="SuccessStatus"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="CommentFromLearnerItem" ViewFunction="CommentFromLearnerItem$DefaultView">' + 
        '<Property Name="ActivityAttemptId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Property Name="Comment" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Location" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="Ordinal" TypeCode="9" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Timestamp" TypeCode="2" Nullable="true" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="CommentFromLmsItem" ViewFunction="CommentFromLmsItem$DefaultView">' + 
        '<Property Name="ActivityPackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="Comment" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Location" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="Timestamp" TypeCode="2" Nullable="true" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="CorrectResponseItem" ViewFunction="CorrectResponseItem$DefaultView">' + 
        '<Property Name="InteractionId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="InteractionItem"/>' +
        '<Property Name="ResponsePattern" TypeCode="2" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="EvaluationCommentItem" ViewFunction="EvaluationCommentItem$DefaultView">' + 
        '<Property Name="InteractionId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="InteractionItem"/>' +
        '<Property Name="Comment" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Location" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="Ordinal" TypeCode="9" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Timestamp" TypeCode="2" Nullable="true" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="ExtensionDataItem" ViewFunction="ExtensionDataItem$DefaultView">' + 
        '<Property Name="ActivityAttemptId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Property Name="InteractionId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Property Name="AttemptObjectiveId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="AttemptObjectiveItem"/>' +
        '<Property Name="Name" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="AttachmentGuid" TypeCode="11" Nullable="true" HasDefault="true"/>' +
        '<Property Name="AttachmentValue" TypeCode="10" Nullable="true" HasDefault="true"/>' +
        '<Property Name="BoolValue" TypeCode="3" Nullable="true" HasDefault="true"/>' +
        '<Property Name="DateTimeValue" TypeCode="4" Nullable="true" HasDefault="true"/>' +
        '<Property Name="DoubleValue" TypeCode="6" Nullable="true" HasDefault="true"/>' +
        '<Property Name="IntValue" TypeCode="9" Nullable="true" HasDefault="true"/>' +
        '<Property Name="StringValue" TypeCode="2" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="GlobalObjectiveItem" ViewFunction="GlobalObjectiveItem$DefaultView">' + 
        '<Property Name="OrganizationId" TypeCode="1" Nullable="true" HasDefault="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="Key" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Description" TypeCode="2" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="InteractionItem" ViewFunction="InteractionItem$DefaultView">' + 
        '<Property Name="ActivityAttemptId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Property Name="InteractionIdFromCmi" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="InteractionType" TypeCode="8" Nullable="true" HasDefault="true" EnumName="InteractionType"/>' +
        '<Property Name="Timestamp" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Weighting" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ResultState" TypeCode="8" Nullable="true" HasDefault="true" EnumName="InteractionResultState"/>' +
        '<Property Name="ResultNumeric" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Latency" TypeCode="6" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Description" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="LearnerResponseBool" TypeCode="3" Nullable="true" HasDefault="true"/>' +
        '<Property Name="LearnerResponseString" TypeCode="2" Nullable="true" HasDefault="true"/>' +
        '<Property Name="LearnerResponseNumeric" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="ScaledScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="RawScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MinScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="MaxScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="EvaluationPoints" TypeCode="5" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="InteractionObjectiveItem" ViewFunction="InteractionObjectiveItem$DefaultView">' + 
        '<Property Name="InteractionId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="InteractionItem"/>' +
        '<Property Name="AttemptObjectiveId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="AttemptObjectiveItem"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="LearnerGlobalObjectiveItem" ViewFunction="LearnerGlobalObjectiveItem$DefaultView">' + 
        '<Property Name="LearnerId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
        '<Property Name="GlobalObjectiveId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="GlobalObjectiveItem"/>' +
        '<Property Name="ScaledScore" TypeCode="5" Nullable="true" HasDefault="true"/>' +
        '<Property Name="SuccessStatus" TypeCode="8" Nullable="false" HasDefault="true" EnumName="SuccessStatus"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="MapActivityObjectiveToGlobalObjectiveItem" ViewFunction="MapActivityObjectiveToGlobalObjectiveItem$DefaultView">' + 
        '<Property Name="ActivityObjectiveId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="ActivityObjectiveItem"/>' +
        '<Property Name="GlobalObjectiveId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="GlobalObjectiveItem"/>' +
        '<Property Name="ReadSatisfiedStatus" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="ReadNormalizedMeasure" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="WriteSatisfiedStatus" TypeCode="3" Nullable="false" HasDefault="true"/>' +
        '<Property Name="WriteNormalizedMeasure" TypeCode="3" Nullable="false" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="PackageItem" ViewFunction="PackageItem$DefaultView">' + 
        '<Property Name="PackageFormat" TypeCode="8" Nullable="false" HasDefault="false" EnumName="PackageFormat"/>' +
        '<Property Name="Location" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Manifest" TypeCode="7" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Warnings" TypeCode="7" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="RubricItem" ViewFunction="RubricItem$DefaultView">' + 
        '<Property Name="InteractionId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="InteractionItem"/>' +
        '<Property Name="Ordinal" TypeCode="9" Nullable="false" HasDefault="false"/>' +
        '<Property Name="IsSatisfied" TypeCode="3" Nullable="true" HasDefault="true"/>' +
        '<Property Name="Points" TypeCode="5" Nullable="true" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="ResourceItem" ViewFunction="ResourceItem$DefaultView">' + 
        '<Property Name="PackageId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="PackageItem"/>' +
        '<Property Name="ResourceXml" TypeCode="7" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="SequencingLogEntryItem" ViewFunction="SequencingLogEntryItem$DefaultView">' + 
        '<Property Name="AttemptId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="AttemptItem"/>' +
        '<Property Name="ActivityAttemptId" TypeCode="1" Nullable="true" HasDefault="false" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Property Name="EventType" TypeCode="8" Nullable="false" HasDefault="false" EnumName="SequencingEventType"/>' +
        '<Property Name="Message" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="NavigationCommand" TypeCode="8" Nullable="false" HasDefault="false" EnumName="NavigationCommand"/>' +
        '<Property Name="Timestamp" TypeCode="4" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="UserItem" ViewFunction="UserItem$DefaultView">' + 
        '<Property Name="Key" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="Name" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="AudioCaptioning" TypeCode="8" Nullable="false" HasDefault="true" EnumName="AudioCaptioning"/>' +
        '<Property Name="AudioLevel" TypeCode="5" Nullable="false" HasDefault="true"/>' +
        '<Property Name="DeliverySpeed" TypeCode="5" Nullable="false" HasDefault="true"/>' +
        '<Property Name="Language" TypeCode="2" Nullable="false" HasDefault="true"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="SiteSettingsItem" ViewFunction="SiteSettingsItem$DefaultView">' + 
        '<Property Name="SiteGuid" TypeCode="11" Nullable="false" HasDefault="false"/>' +
        '<Property Name="SettingsXml" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="SettingsXmlLastModified" TypeCode="4" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="AssignmentItem" ViewFunction="AssignmentItem$DefaultView" DeleteSecurityFunction="AssignmentItem$DeleteSecurity">' + 
        '<Property Name="SPSiteGuid" TypeCode="11" Nullable="false" HasDefault="false"/>' +
        '<Property Name="SPWebGuid" TypeCode="11" Nullable="false" HasDefault="false"/>' +
        '<Property Name="RootActivityId" TypeCode="1" Nullable="true" HasDefault="false" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Property Name="NonELearningLocation" TypeCode="2" Nullable="true" HasDefault="false"/>' +
        '<Property Name="Title" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="StartDate" TypeCode="4" Nullable="false" HasDefault="false"/>' +
        '<Property Name="DueDate" TypeCode="4" Nullable="true" HasDefault="false"/>' +
        '<Property Name="PointsPossible" TypeCode="5" Nullable="true" HasDefault="false"/>' +
        '<Property Name="Description" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="AutoReturn" TypeCode="3" Nullable="false" HasDefault="false"/>' +
        '<Property Name="ShowAnswersToLearners" TypeCode="3" Nullable="false" HasDefault="false"/>' +
        '<Property Name="CreatedBy" TypeCode="1" Nullable="true" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
        '<Property Name="DateCreated" TypeCode="4" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="InstructorAssignmentItem" ViewFunction="InstructorAssignmentItem$DefaultView">' + 
        '<Property Name="AssignmentId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Property Name="InstructorId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="LearnerAssignmentItem" ViewFunction="LearnerAssignmentItem$DefaultView">' + 
        '<Property Name="AssignmentId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Property Name="LearnerId" TypeCode="1" Nullable="false" HasDefault="false" ReferencedItemTypeName="UserItem"/>' +
        '<Property Name="IsFinal" TypeCode="3" Nullable="false" HasDefault="false"/>' +
        '<Property Name="NonELearningStatus" TypeCode="8" Nullable="true" HasDefault="false" EnumName="AttemptStatus"/>' +
        '<Property Name="FinalPoints" TypeCode="5" Nullable="true" HasDefault="false"/>' +
        '<Property Name="InstructorComments" TypeCode="2" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<ItemType Name="UserWebListItem" ViewFunction="UserWebListItem$DefaultView">' + 
        '<Property Name="OwnerKey" TypeCode="2" Nullable="false" HasDefault="false"/>' +
        '<Property Name="SPSiteGuid" TypeCode="11" Nullable="false" HasDefault="false"/>' +
        '<Property Name="SPWebGuid" TypeCode="11" Nullable="false" HasDefault="false"/>' +
        '<Property Name="LastAccessTime" TypeCode="4" Nullable="false" HasDefault="false"/>' +
    '</ItemType>'
SET @schema = @schema +
    '<Enum Name="AudioCaptioning">' + 
        '<Value Name="Off" Value="-1"/>' + 
        '<Value Name="NoChange" Value="0"/>' + 
        '<Value Name="On" Value="1"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="CompletionStatus">' + 
        '<Value Name="Unknown" Value="0"/>' + 
        '<Value Name="Completed" Value="1"/>' + 
        '<Value Name="Incomplete" Value="2"/>' + 
        '<Value Name="NotAttempted" Value="3"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="ExitMode">' + 
        '<Value Name="Undetermined" Value="0"/>' + 
        '<Value Name="Logout" Value="1"/>' + 
        '<Value Name="Normal" Value="2"/>' + 
        '<Value Name="TimeOut" Value="3"/>' + 
        '<Value Name="Suspended" Value="4"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="DisplayMode">' + 
        '<Value Name="Normal" Value="0"/>' + 
        '<Value Name="Browse" Value="1"/>' + 
        '<Value Name="Review" Value="2"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="SuccessStatus">' + 
        '<Value Name="Unknown" Value="0"/>' + 
        '<Value Name="Failed" Value="1"/>' + 
        '<Value Name="Passed" Value="2"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="TimeLimitAction">' + 
        '<Value Name="ContinueNoMessage" Value="0"/>' + 
        '<Value Name="ContinueWithMessage" Value="1"/>' + 
        '<Value Name="ExitNoMessage" Value="2"/>' + 
        '<Value Name="ExitWithMessage" Value="3"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="InteractionType">' + 
        '<Value Name="Other" Value="0"/>' + 
        '<Value Name="FillIn" Value="1"/>' + 
        '<Value Name="Likert" Value="2"/>' + 
        '<Value Name="LongFillIn" Value="3"/>' + 
        '<Value Name="Matching" Value="4"/>' + 
        '<Value Name="MultipleChoice" Value="5"/>' + 
        '<Value Name="Numeric" Value="6"/>' + 
        '<Value Name="Performance" Value="7"/>' + 
        '<Value Name="Sequencing" Value="8"/>' + 
        '<Value Name="TrueFalse" Value="9"/>' + 
        '<Value Name="Essay" Value="10"/>' + 
        '<Value Name="Attachment" Value="11"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="InteractionResultState">' + 
        '<Value Name="None" Value="0"/>' + 
        '<Value Name="Correct" Value="1"/>' + 
        '<Value Name="Incorrect" Value="2"/>' + 
        '<Value Name="Neutral" Value="3"/>' + 
        '<Value Name="Numeric" Value="4"/>' + 
        '<Value Name="Unanticipated" Value="5"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="PackageFormat">' + 
        '<Value Name="Lrm" Value="0"/>' + 
        '<Value Name="V1p2" Value="1"/>' + 
        '<Value Name="V1p3" Value="2"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="LessonStatus">' + 
        '<Value Name="NotAttempted" Value="0"/>' + 
        '<Value Name="Browsed" Value="1"/>' + 
        '<Value Name="Completed" Value="2"/>' + 
        '<Value Name="Failed" Value="3"/>' + 
        '<Value Name="Incomplete" Value="4"/>' + 
        '<Value Name="Passed" Value="5"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="NavigationCommand">' + 
        '<Value Name="None" Value="0"/>' + 
        '<Value Name="Abandon" Value="1"/>' + 
        '<Value Name="AbandonAll" Value="2"/>' + 
        '<Value Name="ChoiceStart" Value="3"/>' + 
        '<Value Name="Choose" Value="4"/>' + 
        '<Value Name="Continue" Value="5"/>' + 
        '<Value Name="ExitAll" Value="6"/>' + 
        '<Value Name="Previous" Value="7"/>' + 
        '<Value Name="ResumeAll" Value="8"/>' + 
        '<Value Name="Start" Value="9"/>' + 
        '<Value Name="SuspendAll" Value="10"/>' + 
        '<Value Name="UnqualifiedExit" Value="11"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="SequencingEventType">' + 
        '<Value Name="FinalNavigation" Value="0"/>' + 
        '<Value Name="IntermediateNavigation" Value="1"/>' + 
        '<Value Name="Rollup" Value="2"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="AttemptStatus">' + 
        '<Value Name="Active" Value="0"/>' + 
        '<Value Name="Abandoned" Value="1"/>' + 
        '<Value Name="Completed" Value="2"/>' + 
        '<Value Name="Suspended" Value="3"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<Enum Name="LearnerAssignmentState">' + 
        '<Value Name="NotStarted" Value="0"/>' + 
        '<Value Name="Active" Value="1"/>' + 
        '<Value Name="Completed" Value="2"/>' + 
        '<Value Name="Final" Value="3"/>' + 
    '</Enum>'
SET @schema = @schema +
    '<View Name="SeqNavOrganizationGlobalObjectiveView" Function="SeqNavOrganizationGlobalObjectiveView">' + 
        '<Column Name="OrganizationId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="Key" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="ScaledScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="SuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavLearnerGlobalObjectiveView" Function="SeqNavLearnerGlobalObjectiveView">' + 
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="Key" TypeCode="2" Nullable="true"/>' +
        '<Column Name="ScaledScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="SuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavActivityPackageView" Function="SeqNavActivityPackageView">' + 
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackagePath" TypeCode="2" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavActivityTreeView" Function="SeqNavActivityTreeView">' + 
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="ParentActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="DataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="ObjectivesGlobalToSystem" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptView" Function="SeqNavAttemptView">' + 
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="AttemptStatus" TypeCode="8" Nullable="true" EnumName="AttemptStatus"/>' +
        '<Column Name="LogDetailSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="LogFinalSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="LogRollup" TypeCode="3" Nullable="true"/>' +
        '<Column Name="CurrentActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="SuspendedActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackagePath" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="LearnerName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerAudioCaptioning" TypeCode="8" Nullable="true" EnumName="AudioCaptioning"/>' +
        '<Column Name="LearnerAudioLevel" TypeCode="5" Nullable="true"/>' +
        '<Column Name="LearnerDeliverySpeed" TypeCode="5" Nullable="true"/>' +
        '<Column Name="LearnerLanguage" TypeCode="2" Nullable="true"/>' +
        '<Column Name="StartedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="FinishedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="TotalPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="SuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
        '<Column Name="CompletionStatus" TypeCode="8" Nullable="true" EnumName="CompletionStatus"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavActivityAttemptView" Function="SeqNavActivityAttemptView">' + 
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="DataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="SequencingDataCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="RandomPlacement" TypeCode="9" Nullable="true"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ActivityPackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="StaticDataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="ParentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="ObjectivesGlobalToSystem" TypeCode="3" Nullable="true"/>' +
        '<Column Name="CompletionStatus" TypeCode="8" Nullable="true" EnumName="CompletionStatus"/>' +
        '<Column Name="AttemptCount" TypeCode="9" Nullable="true"/>' +
        '<Column Name="EvaluationPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="Exit" TypeCode="8" Nullable="true" EnumName="ExitMode"/>' +
        '<Column Name="LessonStatus" TypeCode="8" Nullable="true" EnumName="LessonStatus"/>' +
        '<Column Name="Location" TypeCode="2" Nullable="true"/>' +
        '<Column Name="MinScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="MaxScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ProgressMeasure" TypeCode="5" Nullable="true"/>' +
        '<Column Name="RawScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ScaledScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="SessionStartTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="SessionTime" TypeCode="6" Nullable="true"/>' +
        '<Column Name="SuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
        '<Column Name="SuspendData" TypeCode="2" Nullable="true"/>' +
        '<Column Name="TotalTime" TypeCode="6" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavCurrentActivityAttemptView" Function="SeqNavCurrentActivityAttemptView">' + 
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="DataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="SequencingDataCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="RandomPlacement" TypeCode="9" Nullable="true"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="StaticDataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="ObjectivesGlobalToSystem" TypeCode="3" Nullable="true"/>' +
        '<Column Name="Credit" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavCurrentCommentFromLmsView" Function="SeqNavCurrentCommentFromLmsView">' + 
        '<Column Name="Comment" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Location" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Timestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="DataModelCache" TypeCode="7" Nullable="true"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptObjectiveView" Function="SeqNavAttemptObjectiveView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="AttemptObjectiveId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptObjectiveItem"/>' +
        '<Column Name="ActivityAttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="CompletionStatus" TypeCode="8" Nullable="true" EnumName="CompletionStatus"/>' +
        '<Column Name="Description" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IsPrimaryObjective" TypeCode="3" Nullable="true"/>' +
        '<Column Name="Key" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LessonStatus" TypeCode="8" Nullable="true" EnumName="LessonStatus"/>' +
        '<Column Name="RawScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="MinScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="MaxScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ProgressMeasure" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ScaledScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="SuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptCommentFromLearnerView" Function="SeqNavAttemptCommentFromLearnerView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ActivityAttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="CommentFromLearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="CommentFromLearnerItem"/>' +
        '<Column Name="Comment" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Location" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Timestamp" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Ordinal" TypeCode="9" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptInteractionView" Function="SeqNavAttemptInteractionView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ActivityAttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="InteractionIdFromCmi" TypeCode="2" Nullable="true"/>' +
        '<Column Name="InteractionType" TypeCode="8" Nullable="true" EnumName="InteractionType"/>' +
        '<Column Name="Timestamp" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Weighting" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ResultState" TypeCode="8" Nullable="true" EnumName="InteractionResultState"/>' +
        '<Column Name="ResultNumeric" TypeCode="5" Nullable="true"/>' +
        '<Column Name="Latency" TypeCode="6" Nullable="true"/>' +
        '<Column Name="Description" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerResponseBool" TypeCode="3" Nullable="true"/>' +
        '<Column Name="LearnerResponseString" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerResponseNumeric" TypeCode="5" Nullable="true"/>' +
        '<Column Name="ScaledScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="RawScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="MinScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="MaxScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="EvaluationPoints" TypeCode="5" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptEvaluationCommentLearnerView" Function="SeqNavAttemptEvaluationCommentLearnerView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="EvaluationCommentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="EvaluationCommentItem"/>' +
        '<Column Name="Comment" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Location" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Timestamp" TypeCode="2" Nullable="true"/>' +
        '<Column Name="Ordinal" TypeCode="9" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptCorrectResponseView" Function="SeqNavAttemptCorrectResponseView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="CorrectResponseId" TypeCode="1" Nullable="true" ReferencedItemTypeName="CorrectResponseItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="ResponsePattern" TypeCode="2" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptInteractionObjectiveView" Function="SeqNavAttemptInteractionObjectiveView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="InteractionObjectiveId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionObjectiveItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="AttemptObjectiveId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptObjectiveItem"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptExtensionDataView" Function="SeqNavAttemptExtensionDataView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ActivityAttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityAttemptItem"/>' +
        '<Column Name="ExtensionDataId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ExtensionDataItem"/>' +
        '<Column Name="Name" TypeCode="2" Nullable="true"/>' +
        '<Column Name="StringValue" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IntValue" TypeCode="9" Nullable="true"/>' +
        '<Column Name="BoolValue" TypeCode="3" Nullable="true"/>' +
        '<Column Name="DoubleValue" TypeCode="6" Nullable="true"/>' +
        '<Column Name="DateTimeValue" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttachmentGuid" TypeCode="11" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptObjectiveExtensionDataView" Function="SeqNavAttemptObjectiveExtensionDataView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ExtensionDataId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ExtensionDataItem"/>' +
        '<Column Name="AttemptObjectiveId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptObjectiveItem"/>' +
        '<Column Name="Name" TypeCode="2" Nullable="true"/>' +
        '<Column Name="StringValue" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IntValue" TypeCode="9" Nullable="true"/>' +
        '<Column Name="BoolValue" TypeCode="3" Nullable="true"/>' +
        '<Column Name="DoubleValue" TypeCode="6" Nullable="true"/>' +
        '<Column Name="DateTimeValue" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttachmentGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AttachmentValue" TypeCode="10" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptInteractionExtensionDataView" Function="SeqNavAttemptInteractionExtensionDataView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="ExtensionDataId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ExtensionDataItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="Name" TypeCode="2" Nullable="true"/>' +
        '<Column Name="StringValue" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IntValue" TypeCode="9" Nullable="true"/>' +
        '<Column Name="BoolValue" TypeCode="3" Nullable="true"/>' +
        '<Column Name="DoubleValue" TypeCode="6" Nullable="true"/>' +
        '<Column Name="DateTimeValue" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttachmentGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AttachmentValue" TypeCode="10" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="SeqNavAttemptRubricView" Function="SeqNavAttemptRubricView">' + 
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="RubricItemId" TypeCode="1" Nullable="true" ReferencedItemTypeName="RubricItem"/>' +
        '<Column Name="InteractionId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InteractionItem"/>' +
        '<Column Name="Ordinal" TypeCode="9" Nullable="true"/>' +
        '<Column Name="IsSatisfied" TypeCode="3" Nullable="true"/>' +
        '<Column Name="Points" TypeCode="5" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="LearnerAssignmentView" Function="LearnerAssignmentView">' + 
        '<Column Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="AttemptGradedPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="LearnerAssignmentState" TypeCode="8" Nullable="true" EnumName="LearnerAssignmentState"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="AssignmentPropertiesView" Function="AssignmentPropertiesView" SecurityFunction="AssignmentPropertiesView$Security">' + 
        '<Column Name="AssignmentSPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentSPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentNonELearningLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentTitle" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentStartDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentDueDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentPointsPossible" TypeCode="5" Nullable="true"/>' +
        '<Column Name="AssignmentDescription" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentShowAnswersToLearners" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedById" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentCreatedByName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedByKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentDateCreated" TypeCode="4" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Parameter Name="AssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Parameter Name="IsInstructor" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="AssignmentListForInstructors" Function="AssignmentListForInstructors" SecurityFunction="AssignmentListForInstructors$Security">' + 
        '<Column Name="AssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Column Name="AssignmentSPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentSPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentNonELearningLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentTitle" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentStartDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentDueDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentPointsPossible" TypeCode="5" Nullable="true"/>' +
        '<Column Name="AssignmentDescription" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentShowAnswersToLearners" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedById" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentCreatedByName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedByKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentDateCreated" TypeCode="4" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="CountTotal" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountNotStarted" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountActive" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountCompleted" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountFinal" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountStarted" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountNotStartedOrActive" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountCompletedOrFinal" TypeCode="9" Nullable="true"/>' +
        '<Column Name="CountNotFinal" TypeCode="9" Nullable="true"/>' +
        '<Column Name="MinGradedPoints" TypeCode="6" Nullable="true"/>' +
        '<Column Name="MaxGradedPoints" TypeCode="6" Nullable="true"/>' +
        '<Column Name="AvgGradedPoints" TypeCode="6" Nullable="true"/>' +
        '<Column Name="MinFinalPoints" TypeCode="6" Nullable="true"/>' +
        '<Column Name="MaxFinalPoints" TypeCode="6" Nullable="true"/>' +
        '<Column Name="AvgFinalPoints" TypeCode="6" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="InstructorAssignmentListForInstructors" Function="InstructorAssignmentListForInstructors" SecurityFunction="InstructorAssignmentListForInstructors$Security">' + 
        '<Column Name="InstructorAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="InstructorAssignmentItem"/>' +
        '<Column Name="InstructorId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="InstructorName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="InstructorKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Column Name="AssignmentSPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentSPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentNonELearningLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentTitle" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentStartDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentDueDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentPointsPossible" TypeCode="5" Nullable="true"/>' +
        '<Column Name="AssignmentDescription" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentShowAnswersToLearners" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedById" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentCreatedByName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedByKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="PackageManifest" TypeCode="7" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="LearnerAssignmentListForLearners" Function="LearnerAssignmentListForLearners" SecurityFunction="LearnerAssignmentListForLearners$Security">' + 
        '<Column Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="LearnerName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IsFinal" TypeCode="3" Nullable="true"/>' +
        '<Column Name="NonELearningStatus" TypeCode="8" Nullable="true" EnumName="AttemptStatus"/>' +
        '<Column Name="FinalPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="InstructorComments" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Column Name="AssignmentSPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentSPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentNonELearningLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentTitle" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentStartDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentDueDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentPointsPossible" TypeCode="5" Nullable="true"/>' +
        '<Column Name="AssignmentDescription" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentShowAnswersToLearners" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedById" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentCreatedByName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedByKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentDateCreated" TypeCode="4" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="AttemptCurrentActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="AttemptSuspendedActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="AttemptStatus" TypeCode="8" Nullable="true" EnumName="AttemptStatus"/>' +
        '<Column Name="AttemptFinishedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttemptLogDetailSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptLogFinalSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptLogRollup" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptStartedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttemptCompletionStatus" TypeCode="8" Nullable="true" EnumName="CompletionStatus"/>' +
        '<Column Name="AttemptSuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
        '<Column Name="AttemptGradedPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="LearnerAssignmentState" TypeCode="8" Nullable="true" EnumName="LearnerAssignmentState"/>' +
        '<Column Name="HasInstructors" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="LearnerAssignmentListForInstructors" Function="LearnerAssignmentListForInstructors" SecurityFunction="LearnerAssignmentListForInstructors$Security">' + 
        '<Column Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
        '<Column Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="LearnerName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="LearnerKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="IsFinal" TypeCode="3" Nullable="true"/>' +
        '<Column Name="NonELearningStatus" TypeCode="8" Nullable="true" EnumName="AttemptStatus"/>' +
        '<Column Name="FinalPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="InstructorComments" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AssignmentItem"/>' +
        '<Column Name="AssignmentSPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentSPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="AssignmentNonELearningLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentTitle" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentStartDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentDueDate" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AssignmentPointsPossible" TypeCode="5" Nullable="true"/>' +
        '<Column Name="AssignmentDescription" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentAutoReturn" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentShowAnswersToLearners" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedById" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
        '<Column Name="AssignmentCreatedByName" TypeCode="2" Nullable="true"/>' +
        '<Column Name="AssignmentCreatedByKey" TypeCode="2" Nullable="true"/>' +
        '<Column Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="PackageManifest" TypeCode="7" Nullable="true"/>' +
        '<Column Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
        '<Column Name="AttemptCurrentActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="AttemptSuspendedActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="AttemptStatus" TypeCode="8" Nullable="true" EnumName="AttemptStatus"/>' +
        '<Column Name="AttemptFinishedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttemptLogDetailSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptLogFinalSequencing" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptLogRollup" TypeCode="3" Nullable="true"/>' +
        '<Column Name="AttemptStartedTimestamp" TypeCode="4" Nullable="true"/>' +
        '<Column Name="AttemptCompletionStatus" TypeCode="8" Nullable="true" EnumName="CompletionStatus"/>' +
        '<Column Name="AttemptSuccessStatus" TypeCode="8" Nullable="true" EnumName="SuccessStatus"/>' +
        '<Column Name="AttemptGradedPoints" TypeCode="5" Nullable="true"/>' +
        '<Column Name="LearnerAssignmentState" TypeCode="8" Nullable="true" EnumName="LearnerAssignmentState"/>' +
        '<Column Name="HasInstructors" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="UserWebList" Function="UserWebList" SecurityFunction="UserWebList$Security">' + 
        '<Column Name="SPSiteGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="SPWebGuid" TypeCode="11" Nullable="true"/>' +
        '<Column Name="LastAccessTime" TypeCode="4" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<View Name="ActivityPackageItemView" Function="ActivityPackageItemView">' + 
        '<Column Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
        '<Column Name="PackageFormat" TypeCode="8" Nullable="true" EnumName="PackageFormat"/>' +
        '<Column Name="PackageLocation" TypeCode="2" Nullable="true"/>' +
        '<Column Name="PackageManifest" TypeCode="7" Nullable="true"/>' +
        '<Column Name="Id" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="ActivityIdFromManifest" TypeCode="2" Nullable="true"/>' +
        '<Column Name="OriginalPlacement" TypeCode="9" Nullable="true"/>' +
        '<Column Name="ParentActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Column Name="PrimaryObjectiveId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityObjectiveItem"/>' +
        '<Column Name="ResourceId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ResourceItem"/>' +
        '<Column Name="PrimaryResourceIdFromManifest" TypeCode="2" Nullable="true"/>' +
        '<Column Name="CompletionThreshold" TypeCode="5" Nullable="true"/>' +
        '<Column Name="Credit" TypeCode="3" Nullable="true"/>' +
        '<Column Name="IsVisibleInContents" TypeCode="3" Nullable="true"/>' +
        '<Column Name="LaunchData" TypeCode="2" Nullable="true"/>' +
        '<Column Name="MaxAttempts" TypeCode="9" Nullable="true"/>' +
        '<Column Name="MaxTimeAllowed" TypeCode="6" Nullable="true"/>' +
        '<Column Name="ResourceParameters" TypeCode="2" Nullable="true"/>' +
        '<Column Name="ScaledPassingScore" TypeCode="5" Nullable="true"/>' +
        '<Column Name="TimeLimitAction" TypeCode="8" Nullable="true" EnumName="TimeLimitAction"/>' +
        '<Column Name="Title" TypeCode="2" Nullable="true"/>' +
        '<Column Name="ObjectivesGlobalToSystem" TypeCode="3" Nullable="true"/>' +
    '</View>'
SET @schema = @schema +
    '<Right Name="AddPackageReferenceRight">' + 
    '</Right>'
SET @schema = @schema +
    '<Right Name="RemovePackageReferenceRight">' + 
        '<Parameter Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="ReadPackageRight">' + 
        '<Parameter Name="PackageId" TypeCode="1" Nullable="true" ReferencedItemTypeName="PackageItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="CreateAttemptRight">' + 
        '<Parameter Name="RootActivityId" TypeCode="1" Nullable="true" ReferencedItemTypeName="ActivityPackageItem"/>' +
        '<Parameter Name="LearnerId" TypeCode="1" Nullable="true" ReferencedItemTypeName="UserItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="DeleteAttemptRight">' + 
        '<Parameter Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="ExecuteSessionRight" SecurityFunction="ExecuteSessionRight">' + 
        '<Parameter Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="ReviewSessionRight" SecurityFunction="ReviewSessionRight">' + 
        '<Parameter Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="RandomAccessSessionRight" SecurityFunction="RandomAccessSessionRight">' + 
        '<Parameter Name="AttemptId" TypeCode="1" Nullable="true" ReferencedItemTypeName="AttemptItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="StartAttemptOnLearnerAssignmentRight" SecurityFunction="StartAttemptOnLearnerAssignmentRight">' + 
        '<Parameter Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="FinishLearnerAssignmentRight" SecurityFunction="FinishLearnerAssignmentRight">' + 
        '<Parameter Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="CompleteLearnerAssignmentRight" SecurityFunction="CompleteLearnerAssignmentRight">' + 
        '<Parameter Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="FinalizeLearnerAssignmentRight" SecurityFunction="FinalizeLearnerAssignmentRight">' + 
        '<Parameter Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</Right>'
SET @schema = @schema +
    '<Right Name="ActivateLearnerAssignmentRight" SecurityFunction="ActivateLearnerAssignmentRight">' + 
        '<Parameter Name="LearnerAssignmentId" TypeCode="1" Nullable="true" ReferencedItemTypeName="LearnerAssignmentItem"/>' +
    '</Right>'
SET @schema = @schema + '</StoreSchema>'
INSERT INTO Configuration (
    EngineVersion,
    SchemaDefinition
) VALUES (
    1,@schema
)

-- Create role that can access the database using LearningStore
CREATE ROLE LearningStore
GRANT SELECT ON Configuration TO LearningStore

-- Create AudioCaptioning table
CREATE TABLE [AudioCaptioning](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [AudioCaptioning] TO LearningStore
INSERT INTO [AudioCaptioning](
    Id,
    Name
) VALUES (
    -1,
    'Off'
)
INSERT INTO [AudioCaptioning](
    Id,
    Name
) VALUES (
    0,
    'NoChange'
)
INSERT INTO [AudioCaptioning](
    Id,
    Name
) VALUES (
    1,
    'On'
)

-- Create CompletionStatus table
CREATE TABLE [CompletionStatus](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [CompletionStatus] TO LearningStore
INSERT INTO [CompletionStatus](
    Id,
    Name
) VALUES (
    0,
    'Unknown'
)
INSERT INTO [CompletionStatus](
    Id,
    Name
) VALUES (
    1,
    'Completed'
)
INSERT INTO [CompletionStatus](
    Id,
    Name
) VALUES (
    2,
    'Incomplete'
)
INSERT INTO [CompletionStatus](
    Id,
    Name
) VALUES (
    3,
    'NotAttempted'
)

-- Create ExitMode table
CREATE TABLE [ExitMode](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [ExitMode] TO LearningStore
INSERT INTO [ExitMode](
    Id,
    Name
) VALUES (
    0,
    'Undetermined'
)
INSERT INTO [ExitMode](
    Id,
    Name
) VALUES (
    1,
    'Logout'
)
INSERT INTO [ExitMode](
    Id,
    Name
) VALUES (
    2,
    'Normal'
)
INSERT INTO [ExitMode](
    Id,
    Name
) VALUES (
    3,
    'TimeOut'
)
INSERT INTO [ExitMode](
    Id,
    Name
) VALUES (
    4,
    'Suspended'
)

-- Create DisplayMode table
CREATE TABLE [DisplayMode](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [DisplayMode] TO LearningStore
INSERT INTO [DisplayMode](
    Id,
    Name
) VALUES (
    0,
    'Normal'
)
INSERT INTO [DisplayMode](
    Id,
    Name
) VALUES (
    1,
    'Browse'
)
INSERT INTO [DisplayMode](
    Id,
    Name
) VALUES (
    2,
    'Review'
)

-- Create SuccessStatus table
CREATE TABLE [SuccessStatus](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [SuccessStatus] TO LearningStore
INSERT INTO [SuccessStatus](
    Id,
    Name
) VALUES (
    0,
    'Unknown'
)
INSERT INTO [SuccessStatus](
    Id,
    Name
) VALUES (
    1,
    'Failed'
)
INSERT INTO [SuccessStatus](
    Id,
    Name
) VALUES (
    2,
    'Passed'
)

-- Create TimeLimitAction table
CREATE TABLE [TimeLimitAction](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [TimeLimitAction] TO LearningStore
INSERT INTO [TimeLimitAction](
    Id,
    Name
) VALUES (
    0,
    'ContinueNoMessage'
)
INSERT INTO [TimeLimitAction](
    Id,
    Name
) VALUES (
    1,
    'ContinueWithMessage'
)
INSERT INTO [TimeLimitAction](
    Id,
    Name
) VALUES (
    2,
    'ExitNoMessage'
)
INSERT INTO [TimeLimitAction](
    Id,
    Name
) VALUES (
    3,
    'ExitWithMessage'
)

-- Create InteractionType table
CREATE TABLE [InteractionType](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [InteractionType] TO LearningStore
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    0,
    'Other'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    1,
    'FillIn'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    2,
    'Likert'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    3,
    'LongFillIn'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    4,
    'Matching'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    5,
    'MultipleChoice'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    6,
    'Numeric'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    7,
    'Performance'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    8,
    'Sequencing'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    9,
    'TrueFalse'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    10,
    'Essay'
)
INSERT INTO [InteractionType](
    Id,
    Name
) VALUES (
    11,
    'Attachment'
)

-- Create InteractionResultState table
CREATE TABLE [InteractionResultState](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [InteractionResultState] TO LearningStore
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    0,
    'None'
)
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    1,
    'Correct'
)
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    2,
    'Incorrect'
)
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    3,
    'Neutral'
)
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    4,
    'Numeric'
)
INSERT INTO [InteractionResultState](
    Id,
    Name
) VALUES (
    5,
    'Unanticipated'
)

-- Create PackageFormat table
CREATE TABLE [PackageFormat](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [PackageFormat] TO LearningStore
INSERT INTO [PackageFormat](
    Id,
    Name
) VALUES (
    0,
    'Lrm'
)
INSERT INTO [PackageFormat](
    Id,
    Name
) VALUES (
    1,
    'V1p2'
)
INSERT INTO [PackageFormat](
    Id,
    Name
) VALUES (
    2,
    'V1p3'
)

-- Create LessonStatus table
CREATE TABLE [LessonStatus](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [LessonStatus] TO LearningStore
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    0,
    'NotAttempted'
)
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    1,
    'Browsed'
)
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    2,
    'Completed'
)
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    3,
    'Failed'
)
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    4,
    'Incomplete'
)
INSERT INTO [LessonStatus](
    Id,
    Name
) VALUES (
    5,
    'Passed'
)

-- Create NavigationCommand table
CREATE TABLE [NavigationCommand](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [NavigationCommand] TO LearningStore
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    0,
    'None'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    1,
    'Abandon'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    2,
    'AbandonAll'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    3,
    'ChoiceStart'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    4,
    'Choose'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    5,
    'Continue'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    6,
    'ExitAll'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    7,
    'Previous'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    8,
    'ResumeAll'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    9,
    'Start'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    10,
    'SuspendAll'
)
INSERT INTO [NavigationCommand](
    Id,
    Name
) VALUES (
    11,
    'UnqualifiedExit'
)

-- Create SequencingEventType table
CREATE TABLE [SequencingEventType](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [SequencingEventType] TO LearningStore
INSERT INTO [SequencingEventType](
    Id,
    Name
) VALUES (
    0,
    'FinalNavigation'
)
INSERT INTO [SequencingEventType](
    Id,
    Name
) VALUES (
    1,
    'IntermediateNavigation'
)
INSERT INTO [SequencingEventType](
    Id,
    Name
) VALUES (
    2,
    'Rollup'
)

-- Create AttemptStatus table
CREATE TABLE [AttemptStatus](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [AttemptStatus] TO LearningStore
INSERT INTO [AttemptStatus](
    Id,
    Name
) VALUES (
    0,
    'Active'
)
INSERT INTO [AttemptStatus](
    Id,
    Name
) VALUES (
    1,
    'Abandoned'
)
INSERT INTO [AttemptStatus](
    Id,
    Name
) VALUES (
    2,
    'Completed'
)
INSERT INTO [AttemptStatus](
    Id,
    Name
) VALUES (
    3,
    'Suspended'
)

-- Create LearnerAssignmentState table
CREATE TABLE [LearnerAssignmentState](
    Id int PRIMARY KEY,
    Name varchar(63) NOT NULL
)
GRANT SELECT ON [LearnerAssignmentState] TO LearningStore
INSERT INTO [LearnerAssignmentState](
    Id,
    Name
) VALUES (
    0,
    'NotStarted'
)
INSERT INTO [LearnerAssignmentState](
    Id,
    Name
) VALUES (
    1,
    'Active'
)
INSERT INTO [LearnerAssignmentState](
    Id,
    Name
) VALUES (
    2,
    'Completed'
)
INSERT INTO [LearnerAssignmentState](
    Id,
    Name
) VALUES (
    3,
    'Final'
)

-- Create ActivityAttemptItem table
CREATE TABLE [ActivityAttemptItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [AttemptId] bigint NOT NULL,
    [ActivityPackageId] bigint NOT NULL,
    [CompletionStatus] int NOT NULL DEFAULT 0,
    [AttemptCount] int DEFAULT NULL,
    [DataModelCache] xml DEFAULT NULL,
    [EvaluationPoints] float(24) DEFAULT NULL,
    [Exit] int DEFAULT NULL,
    [LessonStatus] int DEFAULT NULL,
    [Location] nvarchar(1000) DEFAULT NULL,
    [MinScore] float(24) DEFAULT NULL,
    [MaxScore] float(24) DEFAULT NULL,
    [ProgressMeasure] float(24) DEFAULT NULL,
    [RandomPlacement] int DEFAULT NULL,
    [RawScore] float(24) DEFAULT NULL,
    [ScaledScore] float(24) DEFAULT NULL,
    [SequencingDataCache] xml DEFAULT NULL,
    [SessionStartTimestamp] datetime DEFAULT NULL,
    [SessionTime] float(53) DEFAULT NULL,
    [SuccessStatus] int DEFAULT NULL,
    [SuspendData] nvarchar(max) DEFAULT NULL CHECK(LEN([SuspendData])<=4096),
    [TotalTime] float(53) DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [ActivityAttemptItem] TO LearningStore

-- Create ActivityObjectiveItem table
CREATE TABLE [ActivityObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityPackageId] bigint NOT NULL,
    [IsPrimaryObjective] bit NOT NULL DEFAULT 0,
    [Key] nvarchar(max) CHECK(LEN([Key])<=4096),
    [MinNormalizedMeasure] float(24) NOT NULL DEFAULT 1,
    [SatisfiedByMeasure] bit NOT NULL DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [ActivityObjectiveItem] TO LearningStore

-- Create ActivityPackageItem table
CREATE TABLE [ActivityPackageItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityIdFromManifest] nvarchar(max) NOT NULL CHECK(LEN([ActivityIdFromManifest])<=4096),
    [OriginalPlacement] int NOT NULL,
    [ParentActivityId] bigint DEFAULT NULL,
    [PackageId] bigint NOT NULL,
    [PrimaryObjectiveId] bigint DEFAULT NULL,
    [ResourceId] bigint DEFAULT NULL,
    [PrimaryResourceFromManifest] nvarchar(2000) DEFAULT NULL,
    [DataModelCache] xml DEFAULT NULL,
    [CompletionThreshold] float(24) DEFAULT NULL,
    [Credit] bit DEFAULT 1,
    [HideContinue] bit NOT NULL DEFAULT 0,
    [HidePrevious] bit NOT NULL DEFAULT 0,
    [HideExit] bit NOT NULL DEFAULT 0,
    [HideAbandon] bit NOT NULL DEFAULT 0,
    [IsVisibleInContents] bit NOT NULL DEFAULT 1,
    [LaunchData] nvarchar(max) DEFAULT NULL CHECK(LEN([LaunchData])<=4096),
    [MasteryScore] float(24) DEFAULT NULL,
    [MaxAttempts] int DEFAULT NULL,
    [MaxTimeAllowed] float(53) DEFAULT 0,
    [ResourceParameters] nvarchar(1000) DEFAULT NULL,
    [ScaledPassingScore] float(24) DEFAULT NULL,
    [TimeLimitAction] int DEFAULT NULL,
    [Title] nvarchar(200) NOT NULL,
    [ObjectivesGlobalToSystem] bit NOT NULL DEFAULT 1
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [ActivityPackageItem] TO LearningStore

-- Create PackageGlobalObjectiveItem table
CREATE TABLE [PackageGlobalObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [LearnerId] bigint NOT NULL,
    [GlobalObjectiveId] bigint NOT NULL,
    [ScaledScore] float(24) DEFAULT NULL,
    [SuccessStatus] int NOT NULL DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [PackageGlobalObjectiveItem] TO LearningStore

-- Create AttemptItem table
CREATE TABLE [AttemptItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [LearnerId] bigint NOT NULL,
    [RootActivityId] bigint NOT NULL,
    [CompletionStatus] int NOT NULL DEFAULT 0,
    [CurrentActivityId] bigint DEFAULT NULL,
    [SuspendedActivityId] bigint DEFAULT NULL,
    [PackageId] bigint NOT NULL,
    [AttemptStatus] int NOT NULL DEFAULT 0,
    [FinishedTimestamp] datetime DEFAULT NULL,
    [LogDetailSequencing] bit NOT NULL DEFAULT 0,
    [LogFinalSequencing] bit NOT NULL DEFAULT 0,
    [LogRollup] bit NOT NULL DEFAULT 0,
    [StartedTimestamp] datetime,
    [SuccessStatus] int NOT NULL DEFAULT 0,
    [TotalPoints] float(24) DEFAULT NULL,
    [LearnerAssignmentId] bigint DEFAULT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [AttemptItem] TO LearningStore

-- Create AttemptObjectiveItem table
CREATE TABLE [AttemptObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityAttemptId] bigint NOT NULL,
    [ActivityObjectiveId] bigint DEFAULT NULL,
    [CompletionStatus] int NOT NULL DEFAULT 0,
    [Description] nvarchar(255) DEFAULT NULL,
    [IsPrimaryObjective] bit NOT NULL DEFAULT 0,
    [Key] nvarchar(max) CHECK(LEN([Key])<=4096),
    [LessonStatus] int DEFAULT 0,
    [RawScore] float(24) DEFAULT NULL,
    [MinScore] float(24) DEFAULT NULL,
    [MaxScore] float(24) DEFAULT NULL,
    [ProgressMeasure] float(24) DEFAULT NULL,
    [ScaledScore] float(24) DEFAULT NULL,
    [SuccessStatus] int NOT NULL DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [AttemptObjectiveItem] TO LearningStore

-- Create CommentFromLearnerItem table
CREATE TABLE [CommentFromLearnerItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityAttemptId] bigint NOT NULL,
    [Comment] nvarchar(max) NOT NULL CHECK(LEN([Comment])<=4096),
    [Location] nvarchar(255),
    [Ordinal] int NOT NULL,
    [Timestamp] nvarchar(28)
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [CommentFromLearnerItem] TO LearningStore

-- Create CommentFromLmsItem table
CREATE TABLE [CommentFromLmsItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityPackageId] bigint NOT NULL,
    [Comment] nvarchar(max) NOT NULL CHECK(LEN([Comment])<=4096),
    [Location] nvarchar(255),
    [Timestamp] nvarchar(28)
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [CommentFromLmsItem] TO LearningStore

-- Create CorrectResponseItem table
CREATE TABLE [CorrectResponseItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [InteractionId] bigint NOT NULL,
    [ResponsePattern] nvarchar(max) NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [CorrectResponseItem] TO LearningStore

-- Create EvaluationCommentItem table
CREATE TABLE [EvaluationCommentItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [InteractionId] bigint NOT NULL,
    [Comment] nvarchar(max) NOT NULL CHECK(LEN([Comment])<=4096),
    [Location] nvarchar(255),
    [Ordinal] int NOT NULL,
    [Timestamp] nvarchar(28)
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [EvaluationCommentItem] TO LearningStore

-- Create ExtensionDataItem table
CREATE TABLE [ExtensionDataItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityAttemptId] bigint DEFAULT NULL,
    [InteractionId] bigint DEFAULT NULL,
    [AttemptObjectiveId] bigint DEFAULT NULL,
    [Name] nvarchar(256) DEFAULT NULL,
    [AttachmentGuid] uniqueidentifier DEFAULT NULL,
    [AttachmentValue] varbinary(max) DEFAULT NULL,
    [BoolValue] bit DEFAULT NULL,
    [DateTimeValue] datetime DEFAULT NULL,
    [DoubleValue] float(53) DEFAULT NULL,
    [IntValue] int DEFAULT NULL,
    [StringValue] nvarchar(max) DEFAULT NULL CHECK(LEN([StringValue])<=4096)
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [ExtensionDataItem] TO LearningStore

-- Create GlobalObjectiveItem table
CREATE TABLE [GlobalObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [OrganizationId] bigint DEFAULT NULL,
    [Key] nvarchar(max) NOT NULL CHECK(LEN([Key])<=4096),
    [Description] nvarchar(max) DEFAULT NULL CHECK(LEN([Description])<=4096)
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [GlobalObjectiveItem] TO LearningStore

-- Create InteractionItem table
CREATE TABLE [InteractionItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityAttemptId] bigint NOT NULL,
    [InteractionIdFromCmi] nvarchar(max) NOT NULL CHECK(LEN([InteractionIdFromCmi])<=4096),
    [InteractionType] int DEFAULT NULL,
    [Timestamp] nvarchar(28) DEFAULT NULL,
    [Weighting] float(24) DEFAULT NULL,
    [ResultState] int DEFAULT NULL,
    [ResultNumeric] float(24) DEFAULT NULL,
    [Latency] float(53) DEFAULT NULL,
    [Description] nvarchar(255) DEFAULT NULL,
    [LearnerResponseBool] bit DEFAULT NULL,
    [LearnerResponseString] nvarchar(max) DEFAULT NULL,
    [LearnerResponseNumeric] float(24) DEFAULT NULL,
    [ScaledScore] float(24) DEFAULT NULL,
    [RawScore] float(24) DEFAULT NULL,
    [MinScore] float(24) DEFAULT NULL,
    [MaxScore] float(24) DEFAULT NULL,
    [EvaluationPoints] float(24) DEFAULT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [InteractionItem] TO LearningStore

-- Create InteractionObjectiveItem table
CREATE TABLE [InteractionObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [InteractionId] bigint NOT NULL,
    [AttemptObjectiveId] bigint NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [InteractionObjectiveItem] TO LearningStore

-- Create LearnerGlobalObjectiveItem table
CREATE TABLE [LearnerGlobalObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [LearnerId] bigint NOT NULL,
    [GlobalObjectiveId] bigint NOT NULL,
    [ScaledScore] float(24) DEFAULT NULL,
    [SuccessStatus] int NOT NULL DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [LearnerGlobalObjectiveItem] TO LearningStore

-- Create MapActivityObjectiveToGlobalObjectiveItem table
CREATE TABLE [MapActivityObjectiveToGlobalObjectiveItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [ActivityObjectiveId] bigint NOT NULL,
    [GlobalObjectiveId] bigint NOT NULL,
    [ReadSatisfiedStatus] bit NOT NULL DEFAULT 1,
    [ReadNormalizedMeasure] bit NOT NULL DEFAULT 1,
    [WriteSatisfiedStatus] bit NOT NULL DEFAULT 0,
    [WriteNormalizedMeasure] bit NOT NULL DEFAULT 0
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [MapActivityObjectiveToGlobalObjectiveItem] TO LearningStore

-- Create PackageItem table
CREATE TABLE [PackageItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [PackageFormat] int NOT NULL,
    [Location] nvarchar(260) NOT NULL,
    [Manifest] xml NOT NULL,
    [Warnings] xml DEFAULT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [PackageItem] TO LearningStore

-- Create RubricItem table
CREATE TABLE [RubricItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [InteractionId] bigint NOT NULL,
    [Ordinal] int NOT NULL,
    [IsSatisfied] bit DEFAULT NULL,
    [Points] float(24) DEFAULT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [RubricItem] TO LearningStore

-- Create ResourceItem table
CREATE TABLE [ResourceItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [PackageId] bigint NOT NULL,
    [ResourceXml] xml NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [ResourceItem] TO LearningStore

-- Create SequencingLogEntryItem table
CREATE TABLE [SequencingLogEntryItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [AttemptId] bigint NOT NULL,
    [ActivityAttemptId] bigint,
    [EventType] int NOT NULL,
    [Message] nvarchar(max) NOT NULL,
    [NavigationCommand] int NOT NULL,
    [Timestamp] datetime NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [SequencingLogEntryItem] TO LearningStore

-- Create UserItem table
CREATE TABLE [UserItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [Key] nvarchar(250) NOT NULL,
    [Name] nvarchar(255) NOT NULL,
    [AudioCaptioning] int NOT NULL DEFAULT 0,
    [AudioLevel] float(24) NOT NULL DEFAULT 1,
    [DeliverySpeed] float(24) NOT NULL DEFAULT 1,
    [Language] nvarchar(255) NOT NULL DEFAULT ''
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [UserItem] TO LearningStore

-- Create SiteSettingsItem table
CREATE TABLE [SiteSettingsItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [SiteGuid] uniqueidentifier NOT NULL,
    [SettingsXml] nvarchar(max) NOT NULL,
    [SettingsXmlLastModified] datetime NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [SiteSettingsItem] TO LearningStore

-- Create AssignmentItem table
CREATE TABLE [AssignmentItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [SPSiteGuid] uniqueidentifier NOT NULL,
    [SPWebGuid] uniqueidentifier NOT NULL,
    [RootActivityId] bigint,
    [NonELearningLocation] nvarchar(1000),
    [Title] nvarchar(1000) NOT NULL,
    [StartDate] datetime NOT NULL,
    [DueDate] datetime,
    [PointsPossible] float(24),
    [Description] nvarchar(max) NOT NULL,
    [AutoReturn] bit NOT NULL,
    [ShowAnswersToLearners] bit NOT NULL,
    [CreatedBy] bigint,
    [DateCreated] datetime NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [AssignmentItem] TO LearningStore

-- Create InstructorAssignmentItem table
CREATE TABLE [InstructorAssignmentItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [AssignmentId] bigint NOT NULL,
    [InstructorId] bigint NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [InstructorAssignmentItem] TO LearningStore

-- Create LearnerAssignmentItem table
CREATE TABLE [LearnerAssignmentItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [AssignmentId] bigint NOT NULL,
    [LearnerId] bigint NOT NULL,
    [IsFinal] bit NOT NULL,
    [NonELearningStatus] int,
    [FinalPoints] float(24),
    [InstructorComments] nvarchar(max) NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [LearnerAssignmentItem] TO LearningStore

-- Create UserWebListItem table
CREATE TABLE [UserWebListItem](
    Id bigint IDENTITY PRIMARY KEY NOT NULL,
    [OwnerKey] nvarchar(250) NOT NULL,
    [SPSiteGuid] uniqueidentifier NOT NULL,
    [SPWebGuid] uniqueidentifier NOT NULL,
    [LastAccessTime] datetime NOT NULL
)
GRANT SELECT, INSERT, DELETE, UPDATE ON [UserWebListItem] TO LearningStore

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_AttemptId FOREIGN KEY ([AttemptId])
REFERENCES [AttemptItem] (Id) ON DELETE CASCADE

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_ActivityPackageId FOREIGN KEY ([ActivityPackageId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_CompletionStatus FOREIGN KEY ([CompletionStatus])
REFERENCES [CompletionStatus] (Id)

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_Exit FOREIGN KEY ([Exit])
REFERENCES [ExitMode] (Id)

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_LessonStatus FOREIGN KEY ([LessonStatus])
REFERENCES [LessonStatus] (Id)

ALTER TABLE [ActivityAttemptItem]
ADD CONSTRAINT FK_ActivityAttemptItem_SuccessStatus FOREIGN KEY ([SuccessStatus])
REFERENCES [SuccessStatus] (Id)

CREATE INDEX AttemptIndex
ON ActivityAttemptItem(AttemptId)

CREATE INDEX ActivityPackageIndex
ON ActivityAttemptItem(ActivityPackageId, AttemptId)

ALTER TABLE [ActivityObjectiveItem]
ADD CONSTRAINT FK_ActivityObjectiveItem_ActivityPackageId FOREIGN KEY ([ActivityPackageId])
REFERENCES [ActivityPackageItem] (Id) ON DELETE CASCADE

CREATE INDEX ActivityPackageIndex
ON ActivityObjectiveItem(ActivityPackageId)

ALTER TABLE [ActivityPackageItem]
ADD CONSTRAINT FK_ActivityPackageItem_ParentActivityId FOREIGN KEY ([ParentActivityId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [ActivityPackageItem]
ADD CONSTRAINT FK_ActivityPackageItem_PackageId FOREIGN KEY ([PackageId])
REFERENCES [PackageItem] (Id) ON DELETE CASCADE

ALTER TABLE [ActivityPackageItem]
ADD CONSTRAINT FK_ActivityPackageItem_PrimaryObjectiveId FOREIGN KEY ([PrimaryObjectiveId])
REFERENCES [ActivityObjectiveItem] (Id)

ALTER TABLE [ActivityPackageItem]
ADD CONSTRAINT FK_ActivityPackageItem_ResourceId FOREIGN KEY ([ResourceId])
REFERENCES [ResourceItem] (Id)

ALTER TABLE [ActivityPackageItem]
ADD CONSTRAINT FK_ActivityPackageItem_TimeLimitAction FOREIGN KEY ([TimeLimitAction])
REFERENCES [TimeLimitAction] (Id)

CREATE INDEX PackageIndex
ON ActivityPackageItem(PackageId)

CREATE INDEX ParentActivityIndex
ON ActivityPackageItem(ParentActivityId)

ALTER TABLE [PackageGlobalObjectiveItem]
ADD CONSTRAINT FK_PackageGlobalObjectiveItem_LearnerId FOREIGN KEY ([LearnerId])
REFERENCES [UserItem] (Id) ON DELETE CASCADE

ALTER TABLE [PackageGlobalObjectiveItem]
ADD CONSTRAINT FK_PackageGlobalObjectiveItem_GlobalObjectiveId FOREIGN KEY ([GlobalObjectiveId])
REFERENCES [GlobalObjectiveItem] (Id) ON DELETE CASCADE

ALTER TABLE [PackageGlobalObjectiveItem]
ADD CONSTRAINT FK_PackageGlobalObjectiveItem_SuccessStatus FOREIGN KEY ([SuccessStatus])
REFERENCES [SuccessStatus] (Id)

CREATE INDEX GlobalObjectiveIndex
ON PackageGlobalObjectiveItem(GlobalObjectiveId)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_LearnerId FOREIGN KEY ([LearnerId])
REFERENCES [UserItem] (Id) ON DELETE CASCADE

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_RootActivityId FOREIGN KEY ([RootActivityId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_CompletionStatus FOREIGN KEY ([CompletionStatus])
REFERENCES [CompletionStatus] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_CurrentActivityId FOREIGN KEY ([CurrentActivityId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_SuspendedActivityId FOREIGN KEY ([SuspendedActivityId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_PackageId FOREIGN KEY ([PackageId])
REFERENCES [PackageItem] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_AttemptStatus FOREIGN KEY ([AttemptStatus])
REFERENCES [AttemptStatus] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_SuccessStatus FOREIGN KEY ([SuccessStatus])
REFERENCES [SuccessStatus] (Id)

ALTER TABLE [AttemptItem]
ADD CONSTRAINT FK_AttemptItem_LearnerAssignmentId FOREIGN KEY ([LearnerAssignmentId])
REFERENCES [LearnerAssignmentItem] (Id) ON DELETE CASCADE

CREATE INDEX LearnerAssignmentIndex
ON AttemptItem(LearnerAssignmentId)
INCLUDE (AttemptStatus)

ALTER TABLE [AttemptObjectiveItem]
ADD CONSTRAINT FK_AttemptObjectiveItem_ActivityAttemptId FOREIGN KEY ([ActivityAttemptId])
REFERENCES [ActivityAttemptItem] (Id) ON DELETE CASCADE

ALTER TABLE [AttemptObjectiveItem]
ADD CONSTRAINT FK_AttemptObjectiveItem_ActivityObjectiveId FOREIGN KEY ([ActivityObjectiveId])
REFERENCES [ActivityObjectiveItem] (Id)

ALTER TABLE [AttemptObjectiveItem]
ADD CONSTRAINT FK_AttemptObjectiveItem_CompletionStatus FOREIGN KEY ([CompletionStatus])
REFERENCES [CompletionStatus] (Id)

ALTER TABLE [AttemptObjectiveItem]
ADD CONSTRAINT FK_AttemptObjectiveItem_LessonStatus FOREIGN KEY ([LessonStatus])
REFERENCES [LessonStatus] (Id)

ALTER TABLE [AttemptObjectiveItem]
ADD CONSTRAINT FK_AttemptObjectiveItem_SuccessStatus FOREIGN KEY ([SuccessStatus])
REFERENCES [SuccessStatus] (Id)

CREATE INDEX ActivityAttemptIndex
ON AttemptObjectiveItem(ActivityAttemptId, ActivityObjectiveId)

ALTER TABLE [CommentFromLearnerItem]
ADD CONSTRAINT FK_CommentFromLearnerItem_ActivityAttemptId FOREIGN KEY ([ActivityAttemptId])
REFERENCES [ActivityAttemptItem] (Id) ON DELETE CASCADE

CREATE INDEX ActivityAttemptIndex
ON CommentFromLearnerItem(ActivityAttemptId)

ALTER TABLE [CommentFromLmsItem]
ADD CONSTRAINT FK_CommentFromLmsItem_ActivityPackageId FOREIGN KEY ([ActivityPackageId])
REFERENCES [ActivityPackageItem] (Id) ON DELETE CASCADE

CREATE INDEX ActivityPackageIndex
ON CommentFromLmsItem(ActivityPackageId)

ALTER TABLE [CorrectResponseItem]
ADD CONSTRAINT FK_CorrectResponseItem_InteractionId FOREIGN KEY ([InteractionId])
REFERENCES [InteractionItem] (Id) ON DELETE CASCADE

CREATE INDEX InteractionIndex
ON CorrectResponseItem(InteractionId)

ALTER TABLE [EvaluationCommentItem]
ADD CONSTRAINT FK_EvaluationCommentItem_InteractionId FOREIGN KEY ([InteractionId])
REFERENCES [InteractionItem] (Id) ON DELETE CASCADE

CREATE INDEX EvaluationCommentIndex
ON EvaluationCommentItem(InteractionId)

ALTER TABLE [ExtensionDataItem]
ADD CONSTRAINT FK_ExtensionDataItem_ActivityAttemptId FOREIGN KEY ([ActivityAttemptId])
REFERENCES [ActivityAttemptItem] (Id) ON DELETE CASCADE

ALTER TABLE [ExtensionDataItem]
ADD CONSTRAINT FK_ExtensionDataItem_InteractionId FOREIGN KEY ([InteractionId])
REFERENCES [InteractionItem] (Id)

ALTER TABLE [ExtensionDataItem]
ADD CONSTRAINT FK_ExtensionDataItem_AttemptObjectiveId FOREIGN KEY ([AttemptObjectiveId])
REFERENCES [AttemptObjectiveItem] (Id)

CREATE INDEX ActivityAttemptIndex
ON ExtensionDataItem(ActivityAttemptId, AttachmentGuid, InteractionId, AttemptObjectiveId)

CREATE INDEX AttachmentGuidIndex
ON ExtensionDataItem(AttachmentGuid, AttemptObjectiveId)

CREATE INDEX InteractionAndObjectiveIndex
ON ExtensionDataItem(InteractionId, AttemptObjectiveId)

ALTER TABLE [GlobalObjectiveItem]
ADD CONSTRAINT FK_GlobalObjectiveItem_OrganizationId FOREIGN KEY ([OrganizationId])
REFERENCES [ActivityPackageItem] (Id) ON DELETE CASCADE

CREATE INDEX OrganizationIndex
ON GlobalObjectiveItem(OrganizationId)

ALTER TABLE [InteractionItem]
ADD CONSTRAINT FK_InteractionItem_ActivityAttemptId FOREIGN KEY ([ActivityAttemptId])
REFERENCES [ActivityAttemptItem] (Id) ON DELETE CASCADE

ALTER TABLE [InteractionItem]
ADD CONSTRAINT FK_InteractionItem_InteractionType FOREIGN KEY ([InteractionType])
REFERENCES [InteractionType] (Id)

ALTER TABLE [InteractionItem]
ADD CONSTRAINT FK_InteractionItem_ResultState FOREIGN KEY ([ResultState])
REFERENCES [InteractionResultState] (Id)

CREATE INDEX ActivityAttemptIndex
ON InteractionItem(ActivityAttemptId)

ALTER TABLE [InteractionObjectiveItem]
ADD CONSTRAINT FK_InteractionObjectiveItem_InteractionId FOREIGN KEY ([InteractionId])
REFERENCES [InteractionItem] (Id) ON DELETE CASCADE

ALTER TABLE [InteractionObjectiveItem]
ADD CONSTRAINT FK_InteractionObjectiveItem_AttemptObjectiveId FOREIGN KEY ([AttemptObjectiveId])
REFERENCES [AttemptObjectiveItem] (Id)

CREATE INDEX InteractionIndex
ON InteractionObjectiveItem(InteractionId)

ALTER TABLE [LearnerGlobalObjectiveItem]
ADD CONSTRAINT FK_LearnerGlobalObjectiveItem_LearnerId FOREIGN KEY ([LearnerId])
REFERENCES [UserItem] (Id) ON DELETE CASCADE

ALTER TABLE [LearnerGlobalObjectiveItem]
ADD CONSTRAINT FK_LearnerGlobalObjectiveItem_GlobalObjectiveId FOREIGN KEY ([GlobalObjectiveId])
REFERENCES [GlobalObjectiveItem] (Id) ON DELETE CASCADE

ALTER TABLE [LearnerGlobalObjectiveItem]
ADD CONSTRAINT FK_LearnerGlobalObjectiveItem_SuccessStatus FOREIGN KEY ([SuccessStatus])
REFERENCES [SuccessStatus] (Id)

CREATE INDEX LearnerIndex
ON LearnerGlobalObjectiveItem(LearnerId, GlobalObjectiveId)

ALTER TABLE [MapActivityObjectiveToGlobalObjectiveItem]
ADD CONSTRAINT FK_MapActivityObjectiveToGlobalObjectiveItem_ActivityObjectiveId FOREIGN KEY ([ActivityObjectiveId])
REFERENCES [ActivityObjectiveItem] (Id) ON DELETE CASCADE

ALTER TABLE [MapActivityObjectiveToGlobalObjectiveItem]
ADD CONSTRAINT FK_MapActivityObjectiveToGlobalObjectiveItem_GlobalObjectiveId FOREIGN KEY ([GlobalObjectiveId])
REFERENCES [GlobalObjectiveItem] (Id)

CREATE INDEX GlobalObjectiveIndex
ON MapActivityObjectiveToGlobalObjectiveItem(GlobalObjectiveId, ActivityObjectiveId)

ALTER TABLE [PackageItem]
ADD CONSTRAINT FK_PackageItem_PackageFormat FOREIGN KEY ([PackageFormat])
REFERENCES [PackageFormat] (Id)

ALTER TABLE [RubricItem]
ADD CONSTRAINT FK_RubricItem_InteractionId FOREIGN KEY ([InteractionId])
REFERENCES [InteractionItem] (Id) ON DELETE CASCADE

CREATE INDEX InteractionIndex
ON RubricItem(InteractionId)

ALTER TABLE [ResourceItem]
ADD CONSTRAINT FK_ResourceItem_PackageId FOREIGN KEY ([PackageId])
REFERENCES [PackageItem] (Id) ON DELETE CASCADE

ALTER TABLE [SequencingLogEntryItem]
ADD CONSTRAINT FK_SequencingLogEntryItem_AttemptId FOREIGN KEY ([AttemptId])
REFERENCES [AttemptItem] (Id) ON DELETE CASCADE

ALTER TABLE [SequencingLogEntryItem]
ADD CONSTRAINT FK_SequencingLogEntryItem_ActivityAttemptId FOREIGN KEY ([ActivityAttemptId])
REFERENCES [ActivityAttemptItem] (Id)

ALTER TABLE [SequencingLogEntryItem]
ADD CONSTRAINT FK_SequencingLogEntryItem_EventType FOREIGN KEY ([EventType])
REFERENCES [SequencingEventType] (Id)

ALTER TABLE [SequencingLogEntryItem]
ADD CONSTRAINT FK_SequencingLogEntryItem_NavigationCommand FOREIGN KEY ([NavigationCommand])
REFERENCES [NavigationCommand] (Id)

ALTER TABLE [UserItem]
ADD CONSTRAINT FK_UserItem_AudioCaptioning FOREIGN KEY ([AudioCaptioning])
REFERENCES [AudioCaptioning] (Id)

CREATE INDEX KeyIndex
ON UserItem([Key])

ALTER TABLE [AssignmentItem]
ADD CONSTRAINT FK_AssignmentItem_RootActivityId FOREIGN KEY ([RootActivityId])
REFERENCES [ActivityPackageItem] (Id)

ALTER TABLE [AssignmentItem]
ADD CONSTRAINT FK_AssignmentItem_CreatedBy FOREIGN KEY ([CreatedBy])
REFERENCES [UserItem] (Id)

CREATE INDEX SPWebIndex
ON AssignmentItem(SPWebGuid)

ALTER TABLE [InstructorAssignmentItem]
ADD CONSTRAINT FK_InstructorAssignmentItem_AssignmentId FOREIGN KEY ([AssignmentId])
REFERENCES [AssignmentItem] (Id) ON DELETE CASCADE

ALTER TABLE [InstructorAssignmentItem]
ADD CONSTRAINT FK_InstructorAssignmentItem_InstructorId FOREIGN KEY ([InstructorId])
REFERENCES [UserItem] (Id) ON DELETE CASCADE

CREATE INDEX AssignmentIndex
ON InstructorAssignmentItem(AssignmentId,InstructorId)

CREATE INDEX InstructorIndex
ON InstructorAssignmentItem(InstructorId,AssignmentId)

ALTER TABLE [LearnerAssignmentItem]
ADD CONSTRAINT FK_LearnerAssignmentItem_AssignmentId FOREIGN KEY ([AssignmentId])
REFERENCES [AssignmentItem] (Id) ON DELETE CASCADE

ALTER TABLE [LearnerAssignmentItem]
ADD CONSTRAINT FK_LearnerAssignmentItem_LearnerId FOREIGN KEY ([LearnerId])
REFERENCES [UserItem] (Id)

ALTER TABLE [LearnerAssignmentItem]
ADD CONSTRAINT FK_LearnerAssignmentItem_NonELearningStatus FOREIGN KEY ([NonELearningStatus])
REFERENCES [AttemptStatus] (Id)

CREATE INDEX AssignmentIndex
ON LearnerAssignmentItem(AssignmentId,LearnerId)
INCLUDE (IsFinal, NonELearningStatus)

CREATE INDEX LearnerIndex
ON LearnerAssignmentItem(LearnerId,AssignmentId)

CREATE INDEX OwnerIndex
ON UserWebListItem(OwnerKey)

GO

-- Create function for the delete security on the AssignmentItem item type
CREATE FUNCTION [AssignmentItem$DeleteSecurity](@UserKey nvarchar(250),@Id bigint)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM InstructorAssignmentItem iai
    INNER JOIN UserItem ui ON iai.InstructorId=ui.Id
    WHERE iai.AssignmentId=@Id AND
    ui.[Key]=@UserKey
    ) THEN 1 ELSE 0 END
    ) | (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM AssignmentItem ai
    INNER JOIN UserItem ui ON ai.CreatedBy=ui.Id
    WHERE ai.Id=@Id AND
    ui.[Key]=@UserKey
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [AssignmentItem$DeleteSecurity] TO LearningStore
GO

-- Create a function that implements the SeqNavOrganizationGlobalObjectiveView view
CREATE FUNCTION [SeqNavOrganizationGlobalObjectiveView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT GlobalObjectiveItem.OrganizationId OrganizationId, GlobalObjectiveItem.[Key] [Key], PackageGlobalObjectiveItem.LearnerId LearnerId, PackageGlobalObjectiveItem.ScaledScore ScaledScore, PackageGlobalObjectiveItem.SuccessStatus SuccessStatus
    FROM GlobalObjectiveItem
    INNER JOIN PackageGlobalObjectiveItem ON PackageGlobalObjectiveItem.GlobalObjectiveId=GlobalObjectiveItem.Id
)
GO
GRANT SELECT ON [SeqNavOrganizationGlobalObjectiveView] TO LearningStore
GO

-- Create a function that implements the SeqNavLearnerGlobalObjectiveView view
CREATE FUNCTION [SeqNavLearnerGlobalObjectiveView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT LearnerGlobalObjectiveItem.LearnerId LearnerId, GlobalObjectiveItem.[Key] [Key], LearnerGlobalObjectiveItem.ScaledScore ScaledScore, LearnerGlobalObjectiveItem.SuccessStatus SuccessStatus
    FROM GlobalObjectiveItem
    INNER JOIN LearnerGlobalObjectiveItem ON LearnerGlobalObjectiveItem.GlobalObjectiveId=GlobalObjectiveItem.Id
)
GO
GRANT SELECT ON [SeqNavLearnerGlobalObjectiveView] TO LearningStore
GO

-- Create a function that implements the SeqNavActivityPackageView view
CREATE FUNCTION [SeqNavActivityPackageView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ActivityPackageItem.Id, ActivityPackageItem.PackageId,PackageItem.PackageFormat PackageFormat, PackageItem.Location PackagePath
    FROM ActivityPackageItem
    INNER JOIN PackageItem ON ActivityPackageItem.PackageId=PackageItem.Id
)
GO
GRANT SELECT ON [SeqNavActivityPackageView] TO LearningStore
GO

-- Create a function that implements the SeqNavActivityTreeView view
CREATE FUNCTION [SeqNavActivityTreeView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    WITH TreeQuery(Id, ParentActivityId, DataModelCache, RootActivityId, ObjectivesGlobalToSystem)
    AS (
    SELECT Id, ParentActivityId, DataModelCache, Id, ObjectivesGlobalToSystem
    FROM ActivityPackageItem
    UNION ALL
    SELECT t1.Id, t1.ParentActivityId, t1.DataModelCache, t2.RootActivityId, t1.ObjectivesGlobalToSystem
    FROM TreeQuery t2
    INNER JOIN ActivityPackageItem t1 ON t1.ParentActivityId=t2.Id )
    SELECT Id, ParentActivityId, DataModelCache, RootActivityId, ObjectivesGlobalToSystem
    FROM TreeQuery
)
GO
GRANT SELECT ON [SeqNavActivityTreeView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptView view
CREATE FUNCTION [SeqNavAttemptView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT AttemptItem.Id Id, AttemptItem.AttemptStatus, AttemptItem.LogDetailSequencing, AttemptItem.LogFinalSequencing, AttemptItem.LogRollup, AttemptItem.CurrentActivityId, AttemptItem.SuspendedActivityId, AttemptItem.RootActivityId,AttemptItem.StartedTimestamp, AttemptItem.FinishedTimestamp,PackageItem.Id PackageId, PackageItem.PackageFormat PackageFormat, PackageItem.Location PackagePath, UserItem.Id LearnerId, UserItem.Name LearnerName, UserItem.AudioCaptioning LearnerAudioCaptioning, UserItem.AudioLevel LearnerAudioLevel, UserItem.DeliverySpeed LearnerDeliverySpeed, UserItem.Language LearnerLanguage, AttemptItem.TotalPoints, AttemptItem.SuccessStatus, AttemptItem.CompletionStatus
    FROM AttemptItem
    INNER JOIN PackageItem ON AttemptItem.PackageId=PackageItem.Id
    INNER JOIN UserItem ON AttemptItem.LearnerId=UserItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptView] TO LearningStore
GO

-- Create a function that implements the SeqNavActivityAttemptView view
CREATE FUNCTION [SeqNavActivityAttemptView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ActivityAttemptItem.Id, ActivityAttemptItem.DataModelCache, ActivityAttemptItem.SequencingDataCache, ActivityAttemptItem.RandomPlacement, ActivityAttemptItem.AttemptId, ActivityAttemptItem.ActivityPackageId, ActivityPackageItem.DataModelCache StaticDataModelCache, ActivityPackageItem.ParentActivityId ParentId, ActivityPackageItem.ObjectivesGlobalToSystem ObjectivesGlobalToSystem, ActivityAttemptItem.CompletionStatus, ActivityAttemptItem.AttemptCount, ActivityAttemptItem.EvaluationPoints, ActivityAttemptItem.[Exit], ActivityAttemptItem.LessonStatus, ActivityAttemptItem.Location, ActivityAttemptItem.MinScore, ActivityAttemptItem.MaxScore, ActivityAttemptItem.ProgressMeasure, ActivityAttemptItem.RawScore, ActivityAttemptItem.ScaledScore, ActivityAttemptItem.SessionStartTimestamp, ActivityAttemptItem.SessionTime, ActivityAttemptItem.SuccessStatus, ActivityAttemptItem.SuspendData, ActivityAttemptItem.TotalTime
    FROM ActivityAttemptItem
    INNER JOIN ActivityPackageItem ON ActivityAttemptItem.ActivityPackageId=ActivityPackageItem.Id
)
GO
GRANT SELECT ON [SeqNavActivityAttemptView] TO LearningStore
GO

-- Create a function that implements the SeqNavCurrentActivityAttemptView view
CREATE FUNCTION [SeqNavCurrentActivityAttemptView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ActivityAttemptItem.Id, ActivityAttemptItem.DataModelCache DataModelCache, ActivityAttemptItem.SequencingDataCache, ActivityAttemptItem.RandomPlacement, ActivityAttemptItem.AttemptId, ActivityPackageItem.DataModelCache StaticDataModelCache, ActivityPackageItem.ObjectivesGlobalToSystem ObjectivesGlobalToSystem, ActivityPackageItem.Credit Credit
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN ActivityPackageItem ON ActivityAttemptItem.ActivityPackageId=ActivityPackageItem.Id
    WHERE AttemptItem.CurrentActivityId=ActivityPackageItem.Id
)
GO
GRANT SELECT ON [SeqNavCurrentActivityAttemptView] TO LearningStore
GO

-- Create a function that implements the SeqNavCurrentCommentFromLmsView view
CREATE FUNCTION [SeqNavCurrentCommentFromLmsView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT CommentFromLmsItem.Comment, CommentFromLmsItem.Location, CommentFromLmsItem.Timestamp, AttemptItem.Id AttemptId, ActivityAttemptItem.DataModelCache
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN ActivityPackageItem ON ActivityAttemptItem.ActivityPackageId=ActivityPackageItem.Id
    INNER JOIN CommentFromLmsItem ON ActivityPackageItem.Id=CommentFromLmsItem.ActivityPackageId
    WHERE AttemptItem.CurrentActivityId=ActivityPackageItem.Id
)
GO
GRANT SELECT ON [SeqNavCurrentCommentFromLmsView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptObjectiveView view
CREATE FUNCTION [SeqNavAttemptObjectiveView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT AttemptObjectiveItem.Id AttemptObjectiveId, AttemptItem.Id AttemptId, AttemptObjectiveItem.CompletionStatus, AttemptObjectiveItem.Description, AttemptObjectiveItem.[Key], AttemptObjectiveItem.LessonStatus, AttemptObjectiveItem.RawScore, AttemptObjectiveItem.MinScore, AttemptObjectiveItem.MaxScore, AttemptObjectiveItem.ProgressMeasure, AttemptObjectiveItem.ScaledScore, AttemptObjectiveItem.SuccessStatus, AttemptObjectiveItem.ActivityAttemptId, AttemptObjectiveItem.IsPrimaryObjective
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN AttemptObjectiveItem ON AttemptObjectiveItem.ActivityAttemptId=ActivityAttemptItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptObjectiveView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptCommentFromLearnerView view
CREATE FUNCTION [SeqNavAttemptCommentFromLearnerView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT CommentFromLearnerItem.Id CommentFromLearnerId, AttemptItem.Id AttemptId, CommentFromLearnerItem.Comment, CommentFromLearnerItem.Location, CommentFromLearnerItem.Timestamp, CommentFromLearnerItem.ActivityAttemptId, CommentFromLearnerItem.Ordinal
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN CommentFromLearnerItem ON CommentFromLearnerItem.ActivityAttemptId=ActivityAttemptItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptCommentFromLearnerView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptInteractionView view
CREATE FUNCTION [SeqNavAttemptInteractionView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT InteractionItem.Id InteractionId, AttemptItem.Id AttemptId, InteractionItem.InteractionIdFromCmi, InteractionItem.InteractionType, InteractionItem.Timestamp, InteractionItem.Weighting, InteractionItem.ResultState, InteractionItem.ResultNumeric, InteractionItem.Latency, InteractionItem.Description, InteractionItem.LearnerResponseBool, InteractionItem.LearnerResponseString, InteractionItem.LearnerResponseNumeric, InteractionItem.ScaledScore, InteractionItem.RawScore, InteractionItem.MinScore, InteractionItem.MaxScore, InteractionItem.ActivityAttemptId, InteractionItem.EvaluationPoints
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptInteractionView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptEvaluationCommentLearnerView view
CREATE FUNCTION [SeqNavAttemptEvaluationCommentLearnerView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT EvaluationCommentItem.Id EvaluationCommentId, AttemptItem.Id AttemptId, EvaluationCommentItem.Comment, EvaluationCommentItem.Location, EvaluationCommentItem.Timestamp, EvaluationCommentItem.InteractionId, EvaluationCommentItem.Ordinal
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN EvaluationCommentItem ON EvaluationCommentItem.InteractionId=InteractionItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptEvaluationCommentLearnerView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptCorrectResponseView view
CREATE FUNCTION [SeqNavAttemptCorrectResponseView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT CorrectResponseItem.Id CorrectResponseId, AttemptItem.Id AttemptId, CorrectResponseItem.InteractionId, CorrectResponseItem.ResponsePattern
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN CorrectResponseItem ON CorrectResponseItem.InteractionId=InteractionItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptCorrectResponseView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptInteractionObjectiveView view
CREATE FUNCTION [SeqNavAttemptInteractionObjectiveView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT InteractionObjectiveItem.Id InteractionObjectiveId, AttemptItem.Id AttemptId, InteractionObjectiveItem.AttemptObjectiveId, InteractionObjectiveItem.InteractionId
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN InteractionObjectiveItem ON InteractionObjectiveItem.InteractionId=InteractionItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptInteractionObjectiveView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptExtensionDataView view
CREATE FUNCTION [SeqNavAttemptExtensionDataView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ExtensionDataItem.Id ExtensionDataId, AttemptItem.Id AttemptId, ExtensionDataItem.Name, ExtensionDataItem.StringValue, ExtensionDataItem.IntValue, ExtensionDataItem.BoolValue, ExtensionDataItem.DoubleValue, ExtensionDataItem.DateTimeValue, ExtensionDataItem.AttachmentGuid, ExtensionDataItem.ActivityAttemptId
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN ExtensionDataItem ON ExtensionDataItem.ActivityAttemptId=ActivityAttemptItem.Id
    WHERE ExtensionDataItem.AttemptObjectiveId IS NULL AND
    ExtensionDataItem.InteractionId IS NULL
)
GO
GRANT SELECT ON [SeqNavAttemptExtensionDataView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptObjectiveExtensionDataView view
CREATE FUNCTION [SeqNavAttemptObjectiveExtensionDataView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ExtensionDataItem.Id ExtensionDataId, ExtensionDataItem.AttemptObjectiveId, AttemptItem.Id AttemptId, ExtensionDataItem.Name, ExtensionDataItem.StringValue, ExtensionDataItem.IntValue, ExtensionDataItem.BoolValue, ExtensionDataItem.DoubleValue, ExtensionDataItem.DateTimeValue, ExtensionDataItem.AttachmentGuid, ExtensionDataItem.AttachmentValue
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN AttemptObjectiveItem ON AttemptObjectiveItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN ExtensionDataItem ON ExtensionDataItem.AttemptObjectiveId=AttemptObjectiveItem.Id
    WHERE ExtensionDataItem.InteractionId IS NULL AND
    ExtensionDataItem.AttemptObjectiveId IS NOT NULL
)
GO
GRANT SELECT ON [SeqNavAttemptObjectiveExtensionDataView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptInteractionExtensionDataView view
CREATE FUNCTION [SeqNavAttemptInteractionExtensionDataView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT ExtensionDataItem.Id ExtensionDataId, ExtensionDataItem.InteractionId, AttemptItem.Id AttemptId, ExtensionDataItem.Name, ExtensionDataItem.StringValue, ExtensionDataItem.IntValue, ExtensionDataItem.BoolValue, ExtensionDataItem.DoubleValue, ExtensionDataItem.DateTimeValue, ExtensionDataItem.AttachmentGuid, ExtensionDataItem.AttachmentValue
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN ExtensionDataItem ON ExtensionDataItem.InteractionId=InteractionItem.Id
    WHERE ExtensionDataItem.AttemptObjectiveId IS NULL AND
    ExtensionDataItem.InteractionId IS NOT NULL
)
GO
GRANT SELECT ON [SeqNavAttemptInteractionExtensionDataView] TO LearningStore
GO

-- Create a function that implements the SeqNavAttemptRubricView view
CREATE FUNCTION [SeqNavAttemptRubricView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT RubricItem.Id RubricItemId, AttemptItem.Id AttemptId, RubricItem.InteractionId, RubricItem.Ordinal, RubricItem.IsSatisfied, RubricItem.Points
    FROM AttemptItem
    INNER JOIN ActivityAttemptItem ON AttemptItem.Id=ActivityAttemptItem.AttemptId
    INNER JOIN InteractionItem ON InteractionItem.ActivityAttemptId=ActivityAttemptItem.Id
    INNER JOIN RubricItem ON RubricItem.InteractionId=InteractionItem.Id
)
GO
GRANT SELECT ON [SeqNavAttemptRubricView] TO LearningStore
GO

-- Create a function that implements the LearnerAssignmentView view
CREATE FUNCTION [LearnerAssignmentView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from LearnerAssignmentItem -----
    lai.Id                          LearnerAssignmentId,
    lai.LearnerId                   LearnerId,
    ----- from AssignmentItem -----
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.RootActivityId              RootActivityId,
    ----- from AttemptItem -----
    ati.Id AttemptId,
    ati.TotalPoints                 AttemptGradedPoints,
    ----- computed LearnerAssignmentState -----
    dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) LearnerAssignmentState
    -----
    FROM LearnerAssignmentItem lai
    INNER JOIN AssignmentItem asi ON lai.AssignmentId = asi.Id
    LEFT OUTER JOIN AttemptItem ati ON ati.LearnerAssignmentId = lai.Id
)
GO
GRANT SELECT ON [LearnerAssignmentView] TO LearningStore
GO

-- Create a function that implements the AssignmentPropertiesView view
CREATE FUNCTION [AssignmentPropertiesView](@UserKey nvarchar(250),@AssignmentId bigint=NULL,@IsInstructor bit=NULL)
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from AssignmentItem -----
    asi.Id                          AssignmentId,
    asi.SPSiteGuid                  AssignmentSPSiteGuid,
    asi.SPWebGuid                   AssignmentSPWebGuid,
    asi.NonELearningLocation        AssignmentNonELearningLocation,
    asi.Title                       AssignmentTitle,
    asi.StartDate                   AssignmentStartDate,
    asi.DueDate                     AssignmentDueDate,
    asi.PointsPossible              AssignmentPointsPossible,
    asi.Description                 AssignmentDescription,
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.ShowAnswersToLearners       AssignmentShowAnswersToLearners,
    asi.CreatedBy                   AssignmentCreatedById,
    cbui.[Name]                     AssignmentCreatedByName,
    cbui.[Key]                      AssignmentCreatedByKey,
    asi.DateCreated                 AssignmentDateCreated,
    asi.RootActivityId              RootActivityId,
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation
    -----
    FROM AssignmentItem asi
    INNER JOIN UserItem cbui ON cbui.Id = asi.CreatedBy
    LEFT OUTER JOIN ActivityPackageItem api ON asi.RootActivityId = api.Id
    LEFT OUTER JOIN PackageItem pki ON api.PackageId = pki.Id
    WHERE asi.Id = @AssignmentId
)
GO
GRANT SELECT ON [AssignmentPropertiesView] TO LearningStore
GO

-- Create function for the security on the AssignmentPropertiesView view
CREATE FUNCTION [AssignmentPropertiesView$Security](@UserKey nvarchar(250),@AssignmentId bigint=NULL,@IsInstructor bit=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM AssignmentItem asi
    LEFT OUTER JOIN LearnerAssignmentItem lai ON lai.AssignmentId = asi.Id
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = asi.Id
    LEFT OUTER JOIN UserItem lui ON lai.LearnerId = lui.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE asi.Id = @AssignmentId AND
    (((lui.[Key] = @UserKey) AND (@IsInstructor = 0) AND (GETUTCDATE() >= asi.StartDate))
    OR
    ((iui.[Key]=@UserKey) AND (@IsInstructor = 1)))
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [AssignmentPropertiesView$Security] TO LearningStore
GO

-- Create a function that implements the AssignmentListForInstructors view
CREATE FUNCTION [AssignmentListForInstructors](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from AssignmentItem -----
    asi.Id                          AssignmentId,
    asi.SPSiteGuid                  AssignmentSPSiteGuid,
    asi.SPWebGuid                   AssignmentSPWebGuid,
    asi.NonELearningLocation        AssignmentNonELearningLocation,
    asi.Title                       AssignmentTitle,
    asi.StartDate                   AssignmentStartDate,
    asi.DueDate                     AssignmentDueDate,
    asi.PointsPossible              AssignmentPointsPossible,
    asi.Description                 AssignmentDescription,
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.ShowAnswersToLearners       AssignmentShowAnswersToLearners,
    asi.CreatedBy                   AssignmentCreatedById,
    cbui.[Name]                     AssignmentCreatedByName,
    cbui.[Key]                      AssignmentCreatedByKey,
    asi.DateCreated                 AssignmentDateCreated,
    asi.RootActivityId              RootActivityId,
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation,
    ----- from learner assignment computed info -----
    ISNULL(la.CountTotal,0)         CountTotal,
    ISNULL(la.CountNotStarted,0)    CountNotStarted,
    ISNULL(la.CountActive,0)        CountActive,
    ISNULL(la.CountCompleted,0)     CountCompleted,
    ISNULL(la.CountFinal,0)         CountFinal,
    ISNULL(la.CountStarted,0)       CountStarted,
    ISNULL(la.CountNotStartedOrActive,0) CountNotStartedOrActive,
    ISNULL(la.CountCompletedOrFinal,0) CountCompletedOrFinal,
    ISNULL(la.CountNotFinal,0)      CountNotFinal,
    la.MinGradedPoints              MinGradedPoints,
    la.MaxGradedPoints              MaxGradedPoints,
    la.AvgGradedPoints              AvgGradedPoints,
    la.MinFinalPoints               MinFinalPoints,
    la.MaxFinalPoints               MaxFinalPoints,
    la.AvgFinalPoints               AvgFinalPoints
    -----
    FROM AssignmentItem asi
    INNER JOIN UserItem cbui ON cbui.Id = asi.CreatedBy
    INNER JOIN InstructorAssignmentItem iai ON asi.Id = iai.AssignmentId
    INNER JOIN UserItem iui ON iai.InstructorId = iui.Id
    LEFT OUTER JOIN ActivityPackageItem api ON asi.RootActivityId = api.Id
    LEFT OUTER JOIN PackageItem pki ON api.PackageId = pki.Id
    LEFT OUTER JOIN (
    SELECT
    ----- from Assignment -----
    lai.AssignmentId,
    ----- computed CountTotal -----
    COUNT(lai.Id) CountTotal,
    ----- computed CountNotStarted -----
    COUNT(CASE WHEN dbo.IsLearnerAssignmentStarted(asi.RootActivityId, lai.NonELearningStatus, ati.AttemptStatus) = 0 THEN 1 ELSE NULL END) CountNotStarted,
    ----- computed CountActive -----
    COUNT(CASE WHEN dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) = 1 THEN 1 ELSE NULL END) CountActive,
    ----- computed CountCompleted -----
    COUNT(CASE WHEN dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) = 2 THEN 1 ELSE NULL END) CountCompleted,
    ----- computed CountFinal -----
    COUNT(CASE WHEN lai.IsFinal = 1 THEN 1 ELSE NULL END) CountFinal,
    ----- computed CountStarted -----
    COUNT(CASE WHEN dbo.IsLearnerAssignmentStarted(asi.RootActivityId, lai.NonELearningStatus, ati.AttemptStatus) <> 0 THEN 1 ELSE NULL END) CountStarted,
    ----- computed CountNotStartedOrActive -----
    COUNT(CASE WHEN dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) IN (0,1) THEN 1 ELSE NULL END) CountNotStartedOrActive,
    ----- computed CountCompletedOrFinal -----
    COUNT(CASE WHEN dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) IN (2,3) THEN 1 ELSE NULL END) CountCompletedOrFinal,
    ----- computed CountNotFinal -----
    COUNT(CASE WHEN lai.IsFinal = 0 THEN 1 ELSE NULL END) CountNotFinal,
    ----- computed MinGradedPoints -----
    MIN(ati.TotalPoints)              MinGradedPoints,
    ----- computed MaxGradedPoints -----
    MAX(ati.TotalPoints)              MaxGradedPoints,
    ----- computed AvgGradedPoints -----
    AVG(ati.TotalPoints)              AvgGradedPoints,
    ----- computed MinFinalPoints -----
    MIN(lai.FinalPoints)              MinFinalPoints,
    ----- computed MaxFinalPoints -----
    MAX(lai.FinalPoints)              MaxFinalPoints,
    ----- computed AvgFinalPoints -----
    AVG(lai.FinalPoints)              AvgFinalPoints
    -----
    FROM LearnerAssignmentItem lai
    INNER JOIN AssignmentItem asi ON lai.AssignmentId = asi.Id
    LEFT OUTER JOIN AttemptItem ati ON ati.LearnerAssignmentId = lai.Id
    INNER JOIN InstructorAssignmentItem iai ON asi.Id = iai.AssignmentId
    INNER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE iui.[Key] = @UserKey
    GROUP BY lai.AssignmentId) AS la ON asi.Id = la.AssignmentId
    WHERE iui.[Key] = @UserKey
)
GO
GRANT SELECT ON [AssignmentListForInstructors] TO LearningStore
GO

-- Create function for the security on the AssignmentListForInstructors view
CREATE FUNCTION [AssignmentListForInstructors$Security](@UserKey nvarchar(250))
RETURNS bit
AS
BEGIN
    RETURN (1)
END
GO
GRANT EXECUTE ON [AssignmentListForInstructors$Security] TO LearningStore
GO

-- Create a function that implements the InstructorAssignmentListForInstructors view
CREATE FUNCTION [InstructorAssignmentListForInstructors](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from InstructorAssignmentItem -----
    iai.Id                          InstructorAssignmentId,
    iai.InstructorId                InstructorId,
    iui.[Name]                      InstructorName,
    iui.[Key]                       InstructorKey,
    ----- from AssignmentItem -----
    asi.Id                          AssignmentId,
    asi.SPSiteGuid                  AssignmentSPSiteGuid,
    asi.SPWebGuid                   AssignmentSPWebGuid,
    asi.NonELearningLocation        AssignmentNonELearningLocation,
    asi.Title                       AssignmentTitle,
    asi.StartDate                   AssignmentStartDate,
    asi.DueDate                     AssignmentDueDate,
    asi.PointsPossible              AssignmentPointsPossible,
    asi.Description                 AssignmentDescription,
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.ShowAnswersToLearners       AssignmentShowAnswersToLearners,
    asi.CreatedBy                   AssignmentCreatedById,
    cbui.[Name]                     AssignmentCreatedByName,
    cbui.[Key]                      AssignmentCreatedByKey,
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation,
    pki.Manifest                    PackageManifest
    -----
    FROM InstructorAssignmentItem iai
    INNER JOIN AssignmentItem asi ON iai.AssignmentId = asi.Id
    INNER JOIN UserItem iui ON iui.Id = iai.InstructorId
    INNER JOIN UserItem cbui ON cbui.Id = asi.CreatedBy
    LEFT OUTER JOIN ActivityPackageItem api ON asi.RootActivityId = api.Id
    LEFT OUTER JOIN PackageItem pki on api.PackageId = pki.Id
    WHERE EXISTS
    (
    SELECT *
    FROM InstructorAssignmentItem iai2
    INNER JOIN UserItem ui2
    ON iai2.InstructorId = ui2.Id
    WHERE iai2.AssignmentId = asi.Id
    AND ui2.[Key] = @UserKey
    )
)
GO
GRANT SELECT ON [InstructorAssignmentListForInstructors] TO LearningStore
GO

-- Create function for the security on the InstructorAssignmentListForInstructors view
CREATE FUNCTION [InstructorAssignmentListForInstructors$Security](@UserKey nvarchar(250))
RETURNS bit
AS
BEGIN
    RETURN (1)
END
GO
GRANT EXECUTE ON [InstructorAssignmentListForInstructors$Security] TO LearningStore
GO

-- Create a function that implements the LearnerAssignmentListForLearners view
CREATE FUNCTION [LearnerAssignmentListForLearners](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from LearnerAssignmentItem -----
    lai.Id                          LearnerAssignmentId,
    lai.LearnerId                   LearnerId,
    lui.[Name]                      LearnerName,
    lui.[Key]                       LearnerKey,
    lai.IsFinal                     IsFinal,
    lai.NonELearningStatus          NonELearningStatus,
    CASE WHEN lai.IsFinal = 1 THEN lai.FinalPoints ELSE NULL END
    FinalPoints,
    lai.InstructorComments          InstructorComments,
    ----- from AssignmentItem -----
    asi.Id                          AssignmentId,
    asi.SPSiteGuid                  AssignmentSPSiteGuid,
    asi.SPWebGuid                   AssignmentSPWebGuid,
    asi.NonELearningLocation        AssignmentNonELearningLocation,
    asi.Title                       AssignmentTitle,
    asi.StartDate                   AssignmentStartDate,
    asi.DueDate                     AssignmentDueDate,
    asi.PointsPossible              AssignmentPointsPossible,
    asi.Description                 AssignmentDescription,
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.ShowAnswersToLearners       AssignmentShowAnswersToLearners,
    asi.CreatedBy                   AssignmentCreatedById,
    cbui.[Name]                     AssignmentCreatedByName,
    cbui.[Key]                      AssignmentCreatedByKey,
    asi.DateCreated                 AssignmentDateCreated,
    asi.RootActivityId              RootActivityId,
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation,
    ----- from AttemptItem -----
    ati.Id AttemptId,
    ati.CurrentActivityId           AttemptCurrentActivityId,
    ati.SuspendedActivityId         AttemptSuspendedActivityId,
    ati.AttemptStatus               AttemptStatus,
    ati.FinishedTimestamp           AttemptFinishedTimestamp,
    ati.LogDetailSequencing         AttemptLogDetailSequencing,
    ati.LogFinalSequencing          AttemptLogFinalSequencing,
    ati.LogRollup                   AttemptLogRollup,
    ati.StartedTimestamp            AttemptStartedTimestamp,
    ati.CompletionStatus            AttemptCompletionStatus,
    ati.SuccessStatus               AttemptSuccessStatus,
    ati.TotalPoints                 AttemptGradedPoints,
    ----- computed LearnerAssignmentState -----
    dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) LearnerAssignmentState,
    ----- computed HasInstructors -----
    CASE WHEN EXISTS
    (
    SELECT *
    FROM InstructorAssignmentItem iaiH
    WHERE iaiH.AssignmentId = asi.Id
    ) THEN 1 ELSE 0 END             HasInstructors
    -----
    FROM LearnerAssignmentItem lai
    INNER JOIN AssignmentItem asi ON lai.AssignmentId = asi.Id
    INNER JOIN UserItem lui ON lui.Id = lai.LearnerId
    INNER JOIN UserItem cbui ON cbui.Id = asi.CreatedBy
    LEFT OUTER JOIN ActivityPackageItem api ON asi.RootActivityId = api.Id
    LEFT OUTER JOIN PackageItem pki on api.PackageId = pki.Id
    LEFT OUTER JOIN AttemptItem ati ON ati.LearnerAssignmentId = lai.Id
    WHERE lui.[Key] = @UserKey
    AND GETUTCDATE() >= asi.StartDate
)
GO
GRANT SELECT ON [LearnerAssignmentListForLearners] TO LearningStore
GO

-- Create function for the security on the LearnerAssignmentListForLearners view
CREATE FUNCTION [LearnerAssignmentListForLearners$Security](@UserKey nvarchar(250))
RETURNS bit
AS
BEGIN
    RETURN (1)
END
GO
GRANT EXECUTE ON [LearnerAssignmentListForLearners$Security] TO LearningStore
GO

-- Create a function that implements the LearnerAssignmentListForInstructors view
CREATE FUNCTION [LearnerAssignmentListForInstructors](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from LearnerAssignmentItem -----
    lai.Id                          LearnerAssignmentId,
    lai.LearnerId                   LearnerId,
    lui.[Name]                      LearnerName,
    lui.[Key]                       LearnerKey,
    lai.IsFinal                     IsFinal,
    lai.NonELearningStatus          NonELearningStatus,
    lai.FinalPoints                 FinalPoints,
    lai.InstructorComments          InstructorComments,
    ----- from AssignmentItem -----
    asi.Id                          AssignmentId,
    asi.SPSiteGuid                  AssignmentSPSiteGuid,
    asi.SPWebGuid                   AssignmentSPWebGuid,
    asi.NonELearningLocation        AssignmentNonELearningLocation,
    asi.Title                       AssignmentTitle,
    asi.StartDate                   AssignmentStartDate,
    asi.DueDate                     AssignmentDueDate,
    asi.PointsPossible              AssignmentPointsPossible,
    asi.Description                 AssignmentDescription,
    asi.AutoReturn                  AssignmentAutoReturn,
    asi.ShowAnswersToLearners       AssignmentShowAnswersToLearners,
    asi.CreatedBy                   AssignmentCreatedById,
    cbui.[Name]                     AssignmentCreatedByName,
    cbui.[Key]                      AssignmentCreatedByKey,
    asi.RootActivityId              RootActivityId,
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation,
    pki.Manifest                    PackageManifest,
    ----- from AttemptItem -----
    ati.Id AttemptId,
    ati.CurrentActivityId           AttemptCurrentActivityId,
    ati.SuspendedActivityId         AttemptSuspendedActivityId,
    ati.AttemptStatus               AttemptStatus,
    ati.FinishedTimestamp           AttemptFinishedTimestamp,
    ati.LogDetailSequencing         AttemptLogDetailSequencing,
    ati.LogFinalSequencing          AttemptLogFinalSequencing,
    ati.LogRollup                   AttemptLogRollup,
    ati.StartedTimestamp            AttemptStartedTimestamp,
    ati.CompletionStatus            AttemptCompletionStatus,
    ati.SuccessStatus               AttemptSuccessStatus,
    ati.TotalPoints                 AttemptGradedPoints,
    ----- computed LearnerAssignmentState -----
    dbo.GetLearnerAssignmentState(asi.RootActivityId, lai.IsFinal, lai.NonELearningStatus, ati.AttemptStatus) LearnerAssignmentState,
    ----- computed HasInstructors -----
    CASE WHEN EXISTS
    (
    SELECT *
    FROM InstructorAssignmentItem iaiH
    WHERE iaiH.AssignmentId = asi.Id
    ) THEN 1 ELSE 0 END             HasInstructors
    -----
    FROM LearnerAssignmentItem lai
    INNER JOIN AssignmentItem asi ON lai.AssignmentId = asi.Id
    INNER JOIN UserItem lui ON lui.Id = lai.LearnerId
    INNER JOIN UserItem cbui ON cbui.Id = asi.CreatedBy
    INNER JOIN InstructorAssignmentItem iai ON lai.AssignmentId = iai.AssignmentId
    INNER JOIN UserItem iui ON iai.InstructorId = iui.Id
    LEFT OUTER JOIN ActivityPackageItem api ON asi.RootActivityId = api.Id
    LEFT OUTER JOIN PackageItem pki ON api.PackageId = pki.Id
    LEFT OUTER JOIN AttemptItem ati ON ati.LearnerAssignmentId = lai.Id
    WHERE iui.[Key] = @UserKey
)
GO
GRANT SELECT ON [LearnerAssignmentListForInstructors] TO LearningStore
GO

-- Create function for the security on the LearnerAssignmentListForInstructors view
CREATE FUNCTION [LearnerAssignmentListForInstructors$Security](@UserKey nvarchar(250))
RETURNS bit
AS
BEGIN
    RETURN (1)
END
GO
GRANT EXECUTE ON [LearnerAssignmentListForInstructors$Security] TO LearningStore
GO

-- Create a function that implements the UserWebList view
CREATE FUNCTION [UserWebList](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT SPSiteGuid, SPWebGuid, LastAccessTime
    FROM UserWebListItem
    WHERE OwnerKey = @UserKey
)
GO
GRANT SELECT ON [UserWebList] TO LearningStore
GO

-- Create function for the security on the UserWebList view
CREATE FUNCTION [UserWebList$Security](@UserKey nvarchar(250))
RETURNS bit
AS
BEGIN
    RETURN (1)
END
GO
GRANT EXECUTE ON [UserWebList$Security] TO LearningStore
GO

-- Create a function that implements the ActivityPackageItemView view
CREATE FUNCTION [ActivityPackageItemView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT
    ----- from PackageItem -----
    pki.Id                          PackageId,
    pki.PackageFormat               PackageFormat,
    pki.Location                    PackageLocation,
    pki.Manifest                    PackageManifest,
    ----- from ActivityPackageItem -----
    api.Id                          Id,
    api.ActivityIdFromManifest      ActivityIdFromManifest,
    api.OriginalPlacement           OriginalPlacement,
    api.ParentActivityId            ParentActivityId,
    api.PrimaryObjectiveId          PrimaryObjectiveId,
    api.ResourceId                  ResourceId,
    api.PrimaryResourceFromManifest PrimaryResourceIdFromManifest,
    api.CompletionThreshold         CompletionThreshold,
    api.Credit                      Credit,
    api.IsVisibleInContents         IsVisibleInContents,
    api.LaunchData                  LaunchData,
    api.MaxAttempts                 MaxAttempts,
    api.MaxTimeAllowed              MaxTimeAllowed,
    api.ResourceParameters          ResourceParameters,
    api.ScaledPassingScore          ScaledPassingScore,
    api.TimeLimitAction             TimeLimitAction,
    api.Title                       Title,
    api.ObjectivesGlobalToSystem    ObjectivesGlobalToSystem
    -----
    FROM ActivityPackageItem api
    INNER JOIN PackageItem pki on api.PackageId = pki.Id
)
GO
GRANT SELECT ON [ActivityPackageItemView] TO LearningStore
GO

-- Create function for the security on the ExecuteSessionRight right
CREATE FUNCTION [ExecuteSessionRight](@UserKey nvarchar(250),@AttemptId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM AttemptItem ati
    LEFT OUTER JOIN LearnerAssignmentItem lai ON ati.LearnerAssignmentId = lai.Id
    LEFT OUTER JOIN AssignmentItem ai ON lai.AssignmentId = ai.Id
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = ai.Id
    INNER JOIN UserItem lui ON ati.LearnerId = lui.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE ati.Id = @AttemptId AND
    (lui.[Key] = @UserKey OR iui.[Key]=@UserKey)
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [ExecuteSessionRight] TO LearningStore
GO

-- Create function for the security on the ReviewSessionRight right
CREATE FUNCTION [ReviewSessionRight](@UserKey nvarchar(250),@AttemptId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    1
    )
END
GO
GRANT EXECUTE ON [ReviewSessionRight] TO LearningStore
GO

-- Create function for the security on the RandomAccessSessionRight right
CREATE FUNCTION [RandomAccessSessionRight](@UserKey nvarchar(250),@AttemptId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM AttemptItem ati
    LEFT OUTER JOIN LearnerAssignmentItem lai ON ati.LearnerAssignmentId = lai.Id
    LEFT OUTER JOIN AssignmentItem ai ON lai.AssignmentId = ai.Id
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = ai.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE ati.Id = @AttemptId AND
    (ati.AttemptStatus = 1 OR ati.AttemptStatus = 2) AND
    iui.[Key]=@UserKey
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [RandomAccessSessionRight] TO LearningStore
GO

-- Create function for the security on the StartAttemptOnLearnerAssignmentRight right
CREATE FUNCTION [StartAttemptOnLearnerAssignmentRight](@UserKey nvarchar(250),@LearnerAssignmentId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    INNER JOIN AssignmentItem ai ON lai.AssignmentId = ai.Id
    LEFT OUTER JOIN AttemptItem ati ON lai.Id = ati.LearnerAssignmentId
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = lai.AssignmentId
    INNER JOIN UserItem lui ON lai.LearnerId = lui.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    ati.Id IS NULL AND
    ai.RootActivityId IS NOT NULL AND
    (lui.[Key]=@UserKey OR iui.[Key]=@UserKey)
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [StartAttemptOnLearnerAssignmentRight] TO LearningStore
GO

-- Create function for the security on the FinishLearnerAssignmentRight right
CREATE FUNCTION [FinishLearnerAssignmentRight](@UserKey nvarchar(250),@LearnerAssignmentId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = lai.AssignmentId
    INNER JOIN UserItem lui ON lai.LearnerId = lui.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    (lui.[Key]=@UserKey OR iui.[Key]=@UserKey)
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [FinishLearnerAssignmentRight] TO LearningStore
GO

-- Create function for the security on the CompleteLearnerAssignmentRight right
CREATE FUNCTION [CompleteLearnerAssignmentRight](@UserKey nvarchar(250),@LearnerAssignmentId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    LEFT OUTER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = lai.AssignmentId
    INNER JOIN UserItem lui ON lai.LearnerId = lui.Id
    LEFT OUTER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    (lui.[Key]=@UserKey OR iui.[Key]=@UserKey)
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [CompleteLearnerAssignmentRight] TO LearningStore
GO

-- Create function for the security on the FinalizeLearnerAssignmentRight right
CREATE FUNCTION [FinalizeLearnerAssignmentRight](@UserKey nvarchar(250),@LearnerAssignmentId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    INNER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = lai.AssignmentId
    INNER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    iui.[Key]=@UserKey
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [FinalizeLearnerAssignmentRight] TO LearningStore
GO

-- Create function for the security on the ActivateLearnerAssignmentRight right
CREATE FUNCTION [ActivateLearnerAssignmentRight](@UserKey nvarchar(250),@LearnerAssignmentId bigint=NULL)
RETURNS bit
AS
BEGIN
    RETURN (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    INNER JOIN InstructorAssignmentItem iai ON iai.AssignmentId = lai.AssignmentId
    INNER JOIN UserItem iui ON iai.InstructorId = iui.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    iui.[Key]=@UserKey
    ) THEN 1 ELSE 0 END
    ) | (
    CASE WHEN EXISTS
    (
    SELECT *
    FROM LearnerAssignmentItem lai
    INNER JOIN UserItem lui ON lai.LearnerId = lui.Id
    INNER JOIN AssignmentItem ai ON lai.AssignmentId = ai.Id
    WHERE lai.Id = @LearnerAssignmentId AND
    lui.[Key]=@UserKey AND
    ai.RootActivityId IS NULL AND
    (lai.NonELearningStatus IS NULL OR lai.NonELearningStatus = 0)
    ) THEN 1 ELSE 0 END
    )
END
GO
GRANT EXECUTE ON [ActivateLearnerAssignmentRight] TO LearningStore
GO

-- Create function that implements the default view for the ActivityAttemptItem item type
CREATE FUNCTION [ActivityAttemptItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [AttemptId], [ActivityPackageId], [CompletionStatus], [AttemptCount], [DataModelCache], [EvaluationPoints], [Exit], [LessonStatus], [Location], [MinScore], [MaxScore], [ProgressMeasure], [RandomPlacement], [RawScore], [ScaledScore], [SequencingDataCache], [SessionStartTimestamp], [SessionTime], [SuccessStatus], [SuspendData], [TotalTime]
    FROM [ActivityAttemptItem]
)
GO
GRANT SELECT ON [ActivityAttemptItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the ActivityObjectiveItem item type
CREATE FUNCTION [ActivityObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityPackageId], [IsPrimaryObjective], [Key], [MinNormalizedMeasure], [SatisfiedByMeasure]
    FROM [ActivityObjectiveItem]
)
GO
GRANT SELECT ON [ActivityObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the ActivityPackageItem item type
CREATE FUNCTION [ActivityPackageItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityIdFromManifest], [OriginalPlacement], [ParentActivityId], [PackageId], [PrimaryObjectiveId], [ResourceId], [PrimaryResourceFromManifest], [DataModelCache], [CompletionThreshold], [Credit], [HideContinue], [HidePrevious], [HideExit], [HideAbandon], [IsVisibleInContents], [LaunchData], [MasteryScore], [MaxAttempts], [MaxTimeAllowed], [ResourceParameters], [ScaledPassingScore], [TimeLimitAction], [Title], [ObjectivesGlobalToSystem]
    FROM [ActivityPackageItem]
)
GO
GRANT SELECT ON [ActivityPackageItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the PackageGlobalObjectiveItem item type
CREATE FUNCTION [PackageGlobalObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [LearnerId], [GlobalObjectiveId], [ScaledScore], [SuccessStatus]
    FROM [PackageGlobalObjectiveItem]
)
GO
GRANT SELECT ON [PackageGlobalObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the AttemptItem item type
CREATE FUNCTION [AttemptItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [LearnerId], [RootActivityId], [CompletionStatus], [CurrentActivityId], [SuspendedActivityId], [PackageId], [AttemptStatus], [FinishedTimestamp], [LogDetailSequencing], [LogFinalSequencing], [LogRollup], [StartedTimestamp], [SuccessStatus], [TotalPoints], [LearnerAssignmentId]
    FROM [AttemptItem]
)
GO
GRANT SELECT ON [AttemptItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the AttemptObjectiveItem item type
CREATE FUNCTION [AttemptObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityAttemptId], [ActivityObjectiveId], [CompletionStatus], [Description], [IsPrimaryObjective], [Key], [LessonStatus], [RawScore], [MinScore], [MaxScore], [ProgressMeasure], [ScaledScore], [SuccessStatus]
    FROM [AttemptObjectiveItem]
)
GO
GRANT SELECT ON [AttemptObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the CommentFromLearnerItem item type
CREATE FUNCTION [CommentFromLearnerItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityAttemptId], [Comment], [Location], [Ordinal], [Timestamp]
    FROM [CommentFromLearnerItem]
)
GO
GRANT SELECT ON [CommentFromLearnerItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the CommentFromLmsItem item type
CREATE FUNCTION [CommentFromLmsItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityPackageId], [Comment], [Location], [Timestamp]
    FROM [CommentFromLmsItem]
)
GO
GRANT SELECT ON [CommentFromLmsItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the CorrectResponseItem item type
CREATE FUNCTION [CorrectResponseItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [InteractionId], [ResponsePattern]
    FROM [CorrectResponseItem]
)
GO
GRANT SELECT ON [CorrectResponseItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the EvaluationCommentItem item type
CREATE FUNCTION [EvaluationCommentItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [InteractionId], [Comment], [Location], [Ordinal], [Timestamp]
    FROM [EvaluationCommentItem]
)
GO
GRANT SELECT ON [EvaluationCommentItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the ExtensionDataItem item type
CREATE FUNCTION [ExtensionDataItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityAttemptId], [InteractionId], [AttemptObjectiveId], [Name], [AttachmentGuid], [AttachmentValue], [BoolValue], [DateTimeValue], [DoubleValue], [IntValue], [StringValue]
    FROM [ExtensionDataItem]
)
GO
GRANT SELECT ON [ExtensionDataItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the GlobalObjectiveItem item type
CREATE FUNCTION [GlobalObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [OrganizationId], [Key], [Description]
    FROM [GlobalObjectiveItem]
)
GO
GRANT SELECT ON [GlobalObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the InteractionItem item type
CREATE FUNCTION [InteractionItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityAttemptId], [InteractionIdFromCmi], [InteractionType], [Timestamp], [Weighting], [ResultState], [ResultNumeric], [Latency], [Description], [LearnerResponseBool], [LearnerResponseString], [LearnerResponseNumeric], [ScaledScore], [RawScore], [MinScore], [MaxScore], [EvaluationPoints]
    FROM [InteractionItem]
)
GO
GRANT SELECT ON [InteractionItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the InteractionObjectiveItem item type
CREATE FUNCTION [InteractionObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [InteractionId], [AttemptObjectiveId]
    FROM [InteractionObjectiveItem]
)
GO
GRANT SELECT ON [InteractionObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the LearnerGlobalObjectiveItem item type
CREATE FUNCTION [LearnerGlobalObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [LearnerId], [GlobalObjectiveId], [ScaledScore], [SuccessStatus]
    FROM [LearnerGlobalObjectiveItem]
)
GO
GRANT SELECT ON [LearnerGlobalObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the MapActivityObjectiveToGlobalObjectiveItem item type
CREATE FUNCTION [MapActivityObjectiveToGlobalObjectiveItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [ActivityObjectiveId], [GlobalObjectiveId], [ReadSatisfiedStatus], [ReadNormalizedMeasure], [WriteSatisfiedStatus], [WriteNormalizedMeasure]
    FROM [MapActivityObjectiveToGlobalObjectiveItem]
)
GO
GRANT SELECT ON [MapActivityObjectiveToGlobalObjectiveItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the PackageItem item type
CREATE FUNCTION [PackageItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [PackageFormat], [Location], [Manifest], [Warnings]
    FROM [PackageItem]
)
GO
GRANT SELECT ON [PackageItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the RubricItem item type
CREATE FUNCTION [RubricItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [InteractionId], [Ordinal], [IsSatisfied], [Points]
    FROM [RubricItem]
)
GO
GRANT SELECT ON [RubricItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the ResourceItem item type
CREATE FUNCTION [ResourceItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [PackageId], [ResourceXml]
    FROM [ResourceItem]
)
GO
GRANT SELECT ON [ResourceItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the SequencingLogEntryItem item type
CREATE FUNCTION [SequencingLogEntryItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [AttemptId], [ActivityAttemptId], [EventType], [Message], [NavigationCommand], [Timestamp]
    FROM [SequencingLogEntryItem]
)
GO
GRANT SELECT ON [SequencingLogEntryItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the UserItem item type
CREATE FUNCTION [UserItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [Key], [Name], [AudioCaptioning], [AudioLevel], [DeliverySpeed], [Language]
    FROM [UserItem]
)
GO
GRANT SELECT ON [UserItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the SiteSettingsItem item type
CREATE FUNCTION [SiteSettingsItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [SiteGuid], [SettingsXml], [SettingsXmlLastModified]
    FROM [SiteSettingsItem]
)
GO
GRANT SELECT ON [SiteSettingsItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the AssignmentItem item type
CREATE FUNCTION [AssignmentItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [SPSiteGuid], [SPWebGuid], [RootActivityId], [NonELearningLocation], [Title], [StartDate], [DueDate], [PointsPossible], [Description], [AutoReturn], [ShowAnswersToLearners], [CreatedBy], [DateCreated]
    FROM [AssignmentItem]
)
GO
GRANT SELECT ON [AssignmentItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the InstructorAssignmentItem item type
CREATE FUNCTION [InstructorAssignmentItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [AssignmentId], [InstructorId]
    FROM [InstructorAssignmentItem]
)
GO
GRANT SELECT ON [InstructorAssignmentItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the LearnerAssignmentItem item type
CREATE FUNCTION [LearnerAssignmentItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [AssignmentId], [LearnerId], [IsFinal], [NonELearningStatus], [FinalPoints], [InstructorComments]
    FROM [LearnerAssignmentItem]
)
GO
GRANT SELECT ON [LearnerAssignmentItem$DefaultView] TO LearningStore
GO

-- Create function that implements the default view for the UserWebListItem item type
CREATE FUNCTION [UserWebListItem$DefaultView](@UserKey nvarchar(250))
RETURNS TABLE
AS
RETURN (
    SELECT Id, [OwnerKey], [SPSiteGuid], [SPWebGuid], [LastAccessTime]
    FROM [UserWebListItem]
)
GO
GRANT SELECT ON [UserWebListItem$DefaultView] TO LearningStore
GO

COMMIT TRANSACTION
GO

